﻿// Members //
/*****************************************************/
// --------------------
var Validator_ForgotPwd;
// --------------------
var Params_Forgot_Password = new Object();
Params_Forgot_Password.EMAIL = "";
Params_Forgot_Password.LANGUAGE_ABBREVIATION = "0";
Params_Forgot_Password.SOURCE_ID = -1;
var _Params_Forgot_Password = ko.mapping.fromJS(Params_Forgot_Password);
/*****************************************************/

// Specific page "pagebeforecreate" event //
/*****************************************************/
$(document).on("pagebeforecreate", "#pg_forgotpwd", function (event, ui) {
    // -------------------------
    Validator_ForgotPwd = $("#Frm_forgotpwd").validate({
        rules: {
            Txt_Email_pg_forgotpwd: { required: true, email: true }
        }
    });
    // -------------------------

    $(this).on("click", "#Btn_GoToLogin", function (e) {
        // -------------------------
        jq_NavigateToPage("pg_login");
        // -------------------------

        e.preventDefault();
    });

    $(this).on("click", "#Btn_SendPwd", function (e) {
        if ($("#Frm_forgotpwd").valid()) {
            // Connection Check //
            // -------------------------            
            if (!jq_ConnectionExist()) {
                return;
            }
            // -------------------------

            // ---------------------
            jq_ShowMobileLoader();
            jq_BlockUI();
            // ---------------------
            var Forgot_Password_Success = function (result) {
                // ---------------------
                jq_HideMobileLoader();
                jq_UnBlockUI();
                // ---------------------

                // ---------------------
                _Params_Forgot_Password.EMAIL("");
                // ---------------------

                // ---------------------                
                $("#div_ForgotPassSucc").show();
                $("#Frm_forgotpwd").hide();
                // ---------------------

                //jq_DisplayMessage("MSG_GeneralInfo", "Password", "Thank you for your request. Your password was sent to your email address.");                
            };
            var Forgot_Password_Failure = function () {
                // ---------------------
                jq_HideMobileLoader();
                jq_UnBlockUI();
                // ---------------------       

                // ---------------------
                _Params_Forgot_Password.EMAIL("");
                // ---------------------                    
            };
            Forgot_Password(Forgot_Password_Success, Forgot_Password_Failure);
            // ----------------------------
        }
        else {
            // Focus invalid input
            // -------------------
            Validator_ForgotPwd.focusInvalid();
            // -------------------
        }
        e.preventDefault();
    });
});
/*****************************************************/

// Specific page "pagebeforeshow" event //
/*****************************************************/
$(document).on("pagebeforeshow", "#pg_forgotpwd", function (event, ui) {
    // reset form validation
    // ------------------------------------------------------
    Validator_ForgotPwd.resetForm();
    $("input, select, textarea").removeClass("input_error");
    // ------------------------------------------------------
    // ------------------------------------------------------
    $("#div_ForgotPassSucc").hide();
    $("#Frm_forgotpwd").show();
    // ------------------------------------------------------
});
/*****************************************************/
