﻿// Members //
/*****************************************************/
// --------------------
var Validator_Login;
// --------------------
var Params_Authenticate = new Object();
Params_Authenticate.Email = "";
Params_Authenticate.Password = "";
Params_Authenticate.SOURCE_ID = -1;
var _Params_Authenticate = ko.mapping.fromJS(Params_Authenticate);
/*****************************************************/
// --------------------
var obj_Customer;
// --------------------

// Specific page "pagebeforecreate" event //
/*****************************************************/
$(document).on("pagebeforecreate", "#pg_login", function (event, ui) {
    Validator_Login = $("#Frm_login").validate({
        rules: {
            Txt_Email: { required: true, email: true },
            Txt_Password: { required: true }
        }
    });

    $(this).on("click", "#Lnk_ForgotPwd", function (e) {
        jq_NavigateToPage("pg_forgotpwd");
        e.preventDefault();
    });

    $(this).on("click", "#Btn_LogOn", function (e) {        
        if ($("#Frm_login").valid()) {
            // Check if Remember Me is checked so we save credentials locally
            // -------------------------            
            if ($("#Chk_RememberMe").is(':checked')) {
                var Edit_Device_Data_Success = function () {
                    Edit_Device_Data("PASSWORD", _Params_Authenticate.Password());
                };
                Edit_Device_Data("EMAIL", _Params_Authenticate.Email(), Edit_Device_Data_Success);
            }
            else {
                var Delete_Device_Data_By_Key_Success = function () {
                    Delete_Device_Data_By_Key("PASSWORD");
                };
                Delete_Device_Data_By_Key("EMAIL", Delete_Device_Data_By_Key_Success);
            }
            // -------------------------

            // Connection Check //
            // -------------------------            
            if (!jq_ConnectionExist()) {
                return;
            }
            // -------------------------

            // ----------------------------
            jq_ShowMobileLoader();
            jq_BlockUI();
            var Authenticate_Success = function (result) {
                if (result.My_Result == null) {
                    jq_DisplayMessage("MSG_GeneralError", "", "Incorrect Email or Password.");
                    // ---------------------
                    jq_HideMobileLoader();
                    jq_UnBlockUI();
                    // ---------------------
                }
                else {
                    obj_Customer = result.My_Result;
                    /*if (result.My_Result.length == 1) {
                        
                    }*/
                    /*else {
                    obj_Customer = ko.utils.arrayFirst(result.My_Result, function (Customer_Item) {
                    return parseInt(Customer_Item.SOURCE_ID) == parseInt(MyApp_VM.SELECTED_SOURCE().SURROGATE_ID());
                    });

                    if (obj_Customer == null) {
                    obj_Customer = result.My_Result[0];
                    }
                    }*/

                    // Check if Customer does not exist in this SOURCE we have to create it && clear Recipient data
                    // ---------------------
                    if (obj_Customer.SOURCE_ID != MyApp_VM.SELECTED_SOURCE().SURROGATE_ID()) {
                        obj_Customer.DATECREATED = $.format.date(new Date(), "yyyy-MM-dd HH:mm:ss");
                        obj_Customer.DATECREATEDINT = $.format.date(new Date(), "yyyyMMddHHmmss");
                        obj_Customer.IDCUST = -1;
                        obj_Customer.CUSTOMER_ID = -1;
                        obj_Customer.SOURCE_ID = MyApp_VM.SELECTED_SOURCE().SURROGATE_ID();
                        obj_Customer.SHIPPINGNAME = '';
                        obj_Customer.SHIPPINGLASTNAME = '';
                        obj_Customer.SHIPPINGADDRESS = '';
                        obj_Customer.SHIPPINGCITY = '';
                        obj_Customer.SHIPPINGLOCSTATE = '';
                        obj_Customer.SHIPPINGLOCSTATE2 = '';
                        obj_Customer.SHIPPINGLOCCOUNTRY = '';
                        obj_Customer.SHIPPINGZIP = '';
                        obj_Customer.SHIPPINGPHONE = '';
                        obj_Customer.CUSTOMERCOMPANY = '';
                        obj_Customer.COMMPERC = 0;
                        obj_Customer.CONSIGN = '';          // Even if he is a supplier in a country when copying his data we have to remove that he is a Supplier
                    }
                    // ---------------------

                    //alert('Login: ' + obj_Customer.SHIPPINGDATE);
                    ko.mapping.fromJS(obj_Customer, _Customer);
                    //alert('Login: ' + _Customer.SHIPPINGDATE());
                    // ----------------------------
                    MyApp_VM.IS_LOGGEDIN(true);
                    // ----------------------------

                    // ---------------------
                    jq_HideMobileLoader();
                    jq_UnBlockUI();
                    // ---------------------

                    // ----------------------------
                    if (MyApp_VM.LOGIN_PURPOSE() == "MYACC") {          // My Account
                        // Connection Check //
                        // -------------------------            
                        if (!jq_ConnectionExist()) {
                            return;
                        }
                        // -------------------------
                        jq_NavigateToPage("pg_myaccount");
                    }
                    else if (MyApp_VM.LOGIN_PURPOSE() == "CHKOUT") {    // Checkout
                        jq_NavigateToPage("pg_customer");
                    }
                    // ----------------------------
                }
            };
            var Authenticate_Failure = function () {
                jq_HideMobileLoader();
                jq_UnBlockUI();
            };
            Authenticate(Authenticate_Success, Authenticate_Failure);
            // ----------------------------
        }
        else {
            // Focus invalid input
            // -------------------
            Validator_Login.focusInvalid();
            // -------------------
        }
        e.preventDefault();
    });

    $(this).on("click", "#Btn_NewCustomer", function (e) {
        ko.mapping.fromJS(Customer, _Customer);

        jq_NavigateToPage("pg_customer");
        e.preventDefault();
    });
});
/*****************************************************/

// Specific page "pagebeforeshow" event //
/*****************************************************/
$(document).on("pagebeforeshow", "#pg_login", function (event, ui) {
    // reset form validation
    // ------------------------------------------------------
    Validator_Login.resetForm();
    $("input, select, textarea").removeClass("input_error");
    // ------------------------------------------------------    

    // Check if Credentials are saved loccaly to Preset them
    // --------------------------------------                
    var Get_Device_Data_By_Key_Success_Email = function (result) {
        if (result.length > 0) {
            //---------
            _Params_Authenticate.Email(result[0].DATA_VALUE);
            //---------                        

            var Get_Device_Data_By_Key_Success_Password = function (result) {
                if (result.length > 0) {
                    //---------
                    _Params_Authenticate.Password(result[0].DATA_VALUE);
                    //---------

                    //---------
                    //$("#Btn_LogOn").trigger("click");
                    //---------
                }
            };
            Get_Device_Data_By_Key("PASSWORD", Get_Device_Data_By_Key_Success_Password);
        }
    };
    Get_Device_Data_By_Key("EMAIL", Get_Device_Data_By_Key_Success_Email);
    // --------------------------------------
});
/*****************************************************/
