// ------------------
var Params_Get_Local_Featured_Products = new Object();
Params_Get_Local_Featured_Products.SOURCE_CODE = '';
Params_Get_Local_Featured_Products.ADDON = "";
Params_Get_Local_Featured_Products.CATEGORYFEATURED = "";
// ------------------

// ------------------
var Params_Get_Local_Products_By_Criteria = new Object();
Params_Get_Local_Products_By_Criteria.SOURCE_CODE = '';
Params_Get_Local_Products_By_Criteria.IDCATEGORY_LIST = [];
Params_Get_Local_Products_By_Criteria.PRICE_LOWER_BOUND = 0;
Params_Get_Local_Products_By_Criteria.PRICE_UPPER_BOUND = 0;
Params_Get_Local_Products_By_Criteria.FILTER = "";
// ------------------


// ------------------
var Params_Get_Local_Product_Addons = new Object();
Params_Get_Local_Product_Addons.SOURCE_CODE = '';
Params_Get_Local_Product_Addons.IDPRODUCT = 0;
// ------------------

// ------------------
var Params_Get_Local_Product_GroupOptions = new Object();
Params_Get_Local_Product_GroupOptions.SOURCE_CODE = '';
Params_Get_Local_Product_GroupOptions.IDPRODUCT = 0;
// ------------------

// ------------------
var Params_Get_Local_Group_Options = new Object();
Params_Get_Local_Group_Options.SOURCE_CODE = '';
Params_Get_Local_Group_Options.IDOPTIONGROUP = 0;
// ------------------

// ------------------
var Params_Get_Local_Product_Excluded_Options = new Object();
Params_Get_Local_Product_Excluded_Options.SOURCE_CODE = '';
Params_Get_Local_Product_Excluded_Options.IDPRODUCT = 0;
//Params_Get_Local_Product_Excluded_Options.IDOPTIONGROUP = 0;
// ------------------

// ------------------
var Params_Initialize_Card_Head = new Object();
Params_Initialize_Card_Head.SOURCE_CODE = 0;
// ------------------

// ------------------
var Params_Add_To_Cart = new Object();
Params_Add_To_Cart.SOURCE_CODE = 0;
Params_Add_To_Cart.IDPRODUCT_LIST = [];
// ------------------

// ------------------
var Params_Update_Cart = new Object();
Params_Update_Cart.SOURCE_CODE = 0;
Params_Update_Cart.IDPRODUCT = 0
Params_Update_Cart.QUANTITY = 0;
// ------------------

// ------------------
var Params_Remove_From_Cart = new Object();
Params_Remove_From_Cart.SOURCE_CODE = 0;
Params_Remove_From_Cart.IDPRODUCT = 0;
// ------------------

// ------------------
var Params_Calculate_Cart = new Object();
Params_Calculate_Cart.SOURCE_CODE = 0;
// ------------------

// ------------------
var Params_Get_Cart = new Object();
Params_Get_Cart.SOURCE_CODE = 0;
// ------------------



// ------------------
function Get_Local_Featured_Products(Params_Get_Local_Featured_Products, SuccessHandler, FailureHandler, extraData, carouselHandler) {
    try {

        // ---------------
        var js_Source = null;
        // ---------------        

        // Get corresponding Source
        // ---------------
        var Params_Get_Local_Source_By_CODE = new Object();
        Params_Get_Local_Source_By_CODE.CODE = Params_Get_Local_Featured_Products.SOURCE_CODE;

        var Get_Local_Source_By_CODE_Success = function (result) {
            if (result != null) {
                if (result.length > 0) {

                    // ---------------
                    js_Source = result[0];
                    // ---------------

                    // ---------------
                    var Params_Get_Local_Products_By_SOURCE_ID = new Object();
                    Params_Get_Local_Products_By_SOURCE_ID.SOURCE_ID = parseInt(js_Source.SURROGATE_ID);
                    // ---------------

                    // Get valid categories
                    // ---------------
                    var Get_Local_Products_By_SOURCE_ID_Success = function (result) {
                        if (result != null) {

                            for (var i = 0; i < result.length; i++) {

                                // -------------------
                                if
                                    (
                                        (result[i].ACTIVE == -1) &&
                                        (result[i].HOMEPAGE == -1) &&    // Featured?       : Yes
                                        (result[i].TAXEXEMPT == "N")     // Add-On Product? : No

                                    ) {

                                    // -------------------
                                    var match = ko.utils.arrayFirst(extraData(), function (item) {
                                        return result[i].IDPRODUCT == item.IDPRODUCT();
                                    });
                                    // -------------------


                                    // -------------------
                                    if (!match) {
                                        
                                        // -------------------                                                        
                                        result[i].DATA_URI = Get_Image_Url(result[i].SMALLIMAGEURL);
                                        var js_Entry = ko.mapping.fromJS(result[i]);
                                        extraData.push(js_Entry);
                                        // -------------------
                                        if (carouselHandler != null) {                                            
                                            carouselHandler(js_Entry);
                                        }
                                        // -------------------

                                    }
                                    // -------------------
                                }
                                // -------------------
                            }
                        }
                    };
                    // ---------------

                    // ---------------
                    Get_Local_Products_By_SOURCE_ID
					(
						Params_Get_Local_Products_By_SOURCE_ID,
						Get_Local_Products_By_SOURCE_ID_Success,
						null
                    );
                    // ---------------
                }
            }
        }

        Get_Local_Source_By_CODE
		(
			Params_Get_Local_Source_By_CODE,
			Get_Local_Source_By_CODE_Success,
			null);
        // ---------------

    } catch (e) {
        Notify("Get_Local_Featured_Products: " + e.Message);
    }
}
// ------------------

// ------------------
function Get_Local_Products_By_Criteria(Params_Get_Local_Products_By_Criteria, SuccessHandler, FailureHandler, extraData) {
    try {

       
        // Get valid categories
        // ---------------
        var Get_Local_Categories_By_SOURCE_ID_Success = function (result) {

            // For each Category, get corresponding Categories_Products entries
            // --------------
            if (result != null) {
                for (var i = 0; i < result.length; i++) {

                    // --------------------------
                    if (result[i].ADDON != "N") {
                        continue;
                    }
                    // --------------------------

                    if
					(
						(Params_Get_Local_Products_By_Criteria.IDCATEGORY_LIST.length == 0) ||
						($.inArray(result[i].IDCATEGORY, Params_Get_Local_Products_By_Criteria.IDCATEGORY_LIST) != -1)) {

                        // -------------
                        var Params_Get_Local_Categories_products_By_SOURCE_ID = new Object();
                        Params_Get_Local_Categories_products_By_SOURCE_ID.SOURCE_ID = parseInt(js_Source.SURROGATE_ID);

                        var Get_Local_Categories_products_By_SOURCE_ID_Success = function (result, params, selectedCategory) {
                            if (result != null) {

                                for (var k = 0; k < result.length; k++) {

                                    // ---------------------
                                    if (result[k].IDCATEGORY != selectedCategory.IDCATEGORY) {
                                        continue;
                                    }
                                    // ---------------------

                                    // Get Products residing under each Categories_Products entry
                                    // ---------------------
                                    var Params_Get_Local_Products_By_IDPRODUCT = new Object();
                                    Params_Get_Local_Products_By_IDPRODUCT.IDPRODUCT = parseInt(result[k].IDPRODUCT);


                                    var Get_Local_Products_By_IDPRODUCT_Success = function (result, params) {
                                        if (result != null) {
                                            for (var i = 0; i < result.length; i++) {

                                                // ---------------------
                                                if
                                                    (
                                                        (result[i].ACTIVE != -1) ||
                                                        (result[i].SOURCE_ID != parseInt(js_Source.SURROGATE_ID))
                                                    ) {
                                                    continue;
                                                }
                                                // ---------------------

                                                // Filter By SKU
                                                // ---------------------
                                                if
												(
													 (Params_Get_Local_Products_By_Criteria.FILTER == "") ||
													 (result[i].SKU.toUpperCase().indexOf(Params_Get_Local_Products_By_Criteria.FILTER.toUpperCase()) != -1) ||
													 (result[i].RELATEDKEYS.toUpperCase().indexOf(Params_Get_Local_Products_By_Criteria.FILTER.toUpperCase()) != -1) ||
													 (result[i].DESCRIPTION.toUpperCase().indexOf(Params_Get_Local_Products_By_Criteria.FILTER.toUpperCase()) != -1)
												) {


                                                    // Filter by availability
                                                    // ---------------------
                                                    if (result[i].STOCK <= 0) {
                                                        continue;
                                                    }
                                                    // ---------------------


                                                    if
													(
														(result[i].PRICE >= Params_Get_Local_Products_By_Criteria.PRICE_LOWER_BOUND) &&
														(result[i].PRICE <= Params_Get_Local_Products_By_Criteria.PRICE_UPPER_BOUND)
													) {

                                                                                                              
                                                        var match = ko.utils.arrayFirst(extraData(), function (item) {
                                                        return result[i].IDPRODUCT == item.IDPRODUCT();
                                                        });

                                                        if (!match) {

                                                       
                                                            // -------------------
                                                            result[i].DATA_URI = Get_Image_Url(result[i].SMALLIMAGEURL);
                                                            var js_Entry = ko.mapping.fromJS(result[i]);
                                                            extraData.push(js_Entry);
                                                            // -------------------

                                                        }
                                                       
                                                    }
                                                }
                                                // ---------------------
                                            }
                                        }
                                    }

                                    Get_Local_Products_By_IDPRODUCT
									(
										Params_Get_Local_Products_By_IDPRODUCT,
										Get_Local_Products_By_IDPRODUCT_Success,
										null
                                        );
                                    // ---------------------
                                }
                            }
                        };
                        // -------------

                        // -------------
                        Get_Local_Categories_products_By_SOURCE_ID
						(
							Params_Get_Local_Categories_products_By_SOURCE_ID,
							Get_Local_Categories_products_By_SOURCE_ID_Success,
							null,
                            result[i]
                        );
                        // -------------

                    }

                }
            }
            // --------------
        }
        // ---------------

        // Get corresponding Source
        // ---------------
        var Params_Get_Local_Source_By_CODE = new Object();
        Params_Get_Local_Source_By_CODE.CODE = Params_Get_Local_Products_By_Criteria.SOURCE_CODE;

        var Get_Local_Source_By_CODE_Success = function (result) {
            // ---------------
            js_Source = result[0];
            // ---------------

            if
            (
                ($.trim(Params_Get_Local_Products_By_Criteria.FILTER) != "") ||
                (Params_Get_Local_Products_By_Criteria.PRICE_LOWER_BOUND != 0) ||
                (Params_Get_Local_Products_By_Criteria.PRICE_UPPER_BOUND != 100000)
            ) {

                var Params_Get_Local_Products_By_SOURCE_ID = new Object();
                Params_Get_Local_Products_By_SOURCE_ID.SOURCE_ID = parseInt(js_Source.SURROGATE_ID);

                var Get_Local_Products_By_SOURCE_ID_Success = function (result) {
                    if (result != null) {
                        for (var i = 0; i < result.length; i++) {

                            // ---------------------
                            if (result[i].ACTIVE != -1) {
                                continue;
                            }
                            // ---------------------

                            // Filter By SKU
                            // ---------------------
                            if (Params_Get_Local_Products_By_Criteria.FILTER == ""
                            || result[i].SKU.toUpperCase().indexOf(Params_Get_Local_Products_By_Criteria.FILTER.toUpperCase()) != -1
                            || result[i].RELATEDKEYS.toUpperCase().indexOf(Params_Get_Local_Products_By_Criteria.FILTER.toUpperCase()) != -1
                            || result[i].DESCRIPTION.toUpperCase().indexOf(Params_Get_Local_Products_By_Criteria.FILTER.toUpperCase()) != -1) {

                                // Filter by availability
                                // ---------------------
                                if (result[i].STOCK <= 0 || result[i].TAXEXEMPT != "N") {   // Not AddOn product
                                    continue;
                                }
                                // ---------------------

                                if (result[i].PRICE >= Params_Get_Local_Products_By_Criteria.PRICE_LOWER_BOUND
                                && result[i].PRICE <= Params_Get_Local_Products_By_Criteria.PRICE_UPPER_BOUND) {

                                    var match = ko.utils.arrayFirst(extraData(), function (item) {
                                        return result[i].IDPRODUCT == item.IDPRODUCT();
                                    });

                                    if (!match) {
                                        // -------------------
                                        result[i].DATA_URI = Get_Image_Url(result[i].SMALLIMAGEURL);
                                        var js_Entry = ko.mapping.fromJS(result[i]);
                                        extraData.push(js_Entry);
                                        // -------------------                                    
                                    }
                                }
                            }
                            // ---------------------
                        }
                    }
                };
                Get_Local_Products_By_SOURCE_ID
                (
                    Params_Get_Local_Products_By_SOURCE_ID,
                    Get_Local_Products_By_SOURCE_ID_Success,
                    null,
                    null
                );
            }
            else {

                // ---------------
                var Params_Get_Local_Categories_By_SOURCE_ID = new Object();
                Params_Get_Local_Categories_By_SOURCE_ID.SOURCE_ID = parseInt(js_Source.SURROGATE_ID);
                // ---------------

                // ---------------
                Get_Local_Categories_By_SOURCE_ID
			    (
				    Params_Get_Local_Categories_By_SOURCE_ID,
				    Get_Local_Categories_By_SOURCE_ID_Success,
				    null);
                // ---------------
            }
        }

        // ---------------
        Get_Local_Source_By_CODE
		(
			Params_Get_Local_Source_By_CODE,
			Get_Local_Source_By_CODE_Success,
			null
        );
        // ---------------

    } catch (e) {
        Notify("Get_Local_Products_By_Criteria :" + e.message);
    }
}
// ------------------


// ------------------
function Get_Local_Product_GroupOptions(Params_Get_Local_Product_GroupOptions, SuccessHandler, FailureHandler, optionsToExclude, extraData, allProductOptions) {
    try {

        // ---------------
        var js_Source = null;
        // ---------------

        // ---------------
        var Params_Get_Local_Source_By_CODE = new Object();
        Params_Get_Local_Source_By_CODE.CODE = Params_Get_Local_Product_GroupOptions.SOURCE_CODE;

        var Get_Local_Source_By_CODE_Success = function (result) {

            if (result != null) {

                if (result.length > 0) {

                    // ---------------
                    js_Source = result[0];
                    // ---------------                    

                    // ---------------
                    var Params_Get_Local_Optionsgroupsxref_By_IDPRODUCT = new Object();
                    //Params_Get_Local_Optionsgroupsxref_By_SOURCE_ID_IDPRODUCT.SOURCE_ID = parseInt(js_Source.SURROGATE_ID);
                    Params_Get_Local_Optionsgroupsxref_By_IDPRODUCT.IDPRODUCT = parseInt(Params_Get_Local_Product_GroupOptions.IDPRODUCT);

                    var Get_Local_Optionsgroupsxref_By_IDPRODUCT_Success = function (result_Optionsgroupsxref) {
                        //********************
                        var result = [];
                        ko.utils.arrayForEach(result_Optionsgroupsxref, function (item) {
                            if (item.SOURCE_ID == parseInt(js_Source.SURROGATE_ID)) {
                                result.push(item);
                            }
                        });
                        //********************

                        if (result.length > 0) {
                            for (var i = 0; i < result.length; i++) {

                                // ----------------------
                                var Params_Get_Local_Optionsgroups_By_IDOPTIONGROUP = new Object();
                                //Params_Get_Local_Optionsgroups_By_SOURCE_ID_IDOPTIONGROUP.SOURCE_ID = parseInt(js_Source.SURROGATE_ID);
                                Params_Get_Local_Optionsgroups_By_IDOPTIONGROUP.IDOPTIONGROUP = result[i].IDOPTIONGROUP;

                                var Get_Local_Optionsgroups_By_IDOPTIONGROUP_Success = function (result_Optionsgroups, params, extraData1) {
                                    //********************
                                    var result1 = [];
                                    ko.utils.arrayForEach(result_Optionsgroups, function (item) {
                                        if (item.SOURCE_ID == parseInt(js_Source.SURROGATE_ID)) {
                                            result1.push(item);
                                        }
                                    });
                                    //********************

                                    if (result1.length > 0) {
                                        // ---------------------
                                        var js_Current_Group = result1[0];

                                        js_Current_Group.My_Options = [];
                                        js_Current_Group.TXT_VALUE = "";     // Used to set text value if Option is Textbox or Textarea
                                        js_Current_Group.ID_OPTION = null   // Used to set selected Option ID
                                        var _js_Current_Group = ko.mapping.fromJS(js_Current_Group);
                                        extraData.push(_js_Current_Group);
                                        // ---------------------

                                        // Get Options related to this Group
                                        // ---------------------
                                        var Params_Get_Local_Group_Options = new Object();
                                        Params_Get_Local_Group_Options.SOURCE_CODE = js_Source.CODE;
                                        Params_Get_Local_Group_Options.IDOPTIONGROUP = js_Current_Group.IDOPTIONGROUP;

                                        var Get_Local_Group_Options_Success = function () {
                                            if (result.indexOf(extraData1) == result.length - 1) {
                                                // ------------------
                                                if (SuccessHandler) {
                                                    SuccessHandler();
                                                }
                                                // ------------------
                                            }
                                        };

                                        Get_Local_Group_Options
                                        (
                                            Params_Get_Local_Group_Options,
                                            Get_Local_Group_Options_Success,
                                            null,
                                            optionsToExclude,   //Excluded Options (for all products)
                                            _js_Current_Group,   // selectedGroup
                                            allProductOptions   // Available Product options
                                        );
                                        // ---------------------
                                    }

                                };

                                Get_Local_Optionsgroups_By_IDOPTIONGROUP
                                (
                                    Params_Get_Local_Optionsgroups_By_IDOPTIONGROUP,
                                    Get_Local_Optionsgroups_By_IDOPTIONGROUP_Success,
                                    null,
                                    result[i]
                                );
                                // ----------------------

                            }
                        }
                        else {
                            // ------------------
                            if (SuccessHandler) {
                                SuccessHandler();
                            }
                            // ------------------
                        }
                    };

                    Get_Local_Optionsgroupsxref_By_IDPRODUCT
                    (
                        Params_Get_Local_Optionsgroupsxref_By_IDPRODUCT,
                        Get_Local_Optionsgroupsxref_By_IDPRODUCT_Success,
                        null
                    );
                    // ---------------
                }
            }
        };

        Get_Local_Source_By_CODE
		(
			Params_Get_Local_Source_By_CODE,
			Get_Local_Source_By_CODE_Success,
			null
        );
        // ---------------

    }
    catch (e) {
        Notify("Get_Local_Product_GroupOptions: " + e.Message);
    }
}
// ------------------


// ------------------
function Get_Local_Group_Options(Params_Get_Local_Group_Options, SuccessHandler, FailureHandler, optionsToExclude, selectedGroup, allProductOptions) {
    try {
        // ---------------
        var js_Source = null;
        // ---------------

        // ---------------
        var Params_Get_Local_Source_By_CODE = new Object();
        Params_Get_Local_Source_By_CODE.CODE = Params_Get_Local_Group_Options.SOURCE_CODE;

        var Get_Local_Source_By_CODE_Success = function (result) {

            if (result != null) {

                if (result.length > 0) {

                    // ---------------
                    js_Source = result[0];
                    // ---------------    

                    // Get group options
                    // ---------------
                    var Params_Get_Local_Optionsxref_By_IDOPTIONGROUP = new Object();
                    //Params_Get_Local_Optionsxref_By_SOURCE_ID_IDOPTIONGROUP.SOURCE_ID = parseInt(js_Source.SURROGATE_ID);
                    Params_Get_Local_Optionsxref_By_IDOPTIONGROUP.IDOPTIONGROUP = Params_Get_Local_Group_Options.IDOPTIONGROUP;

                    var Get_Local_Optionsxref_By_IDOPTIONGROUP_Success = function (result_Optionsxref) {
                        //********************
                        var result = [];
                        ko.utils.arrayForEach(result_Optionsxref, function (item) {
                            if (item.SOURCE_ID == parseInt(js_Source.SURROGATE_ID)) {
                                result.push(item);
                            }
                        });
                        //********************

                        if (result != null && result.length > 0) {
                            for (var i = 0; i < result.length; i++) {

                                var Params_Get_Local_Options_By_IDOPTION = new Object();
                                //Params_Get_Local_Options_By_SOURCE_ID_IDOPTION.SOURCE_ID = parseInt(js_Source.SURROGATE_ID);
                                Params_Get_Local_Options_By_IDOPTION.IDOPTION = result[i].IDOPTION;

                                var Get_Local_Options_By_IDOPTION_Success = function (result_Options, params, extraData) {
                                    //********************
                                    var result1 = [];
                                    ko.utils.arrayForEach(result_Options, function (item) {
                                        if (item.SOURCE_ID == parseInt(js_Source.SURROGATE_ID)) {
                                            result1.push(item);
                                        }
                                    });
                                    //********************

                                    if ($.inArray(result1[0].IDOPTION, optionsToExclude) == -1) {
                                        allProductOptions.push(ko.mapping.fromJS(result1[0]));       // Get all Available Product Options in one array
                                        selectedGroup.My_Options.push(result1[0]);
                                        /*******************************************************************************************/
                                        if (selectedGroup.OPTIONTYPE() == 'A' || selectedGroup.OPTIONTYPE() == 'T') {
                                            // Set ID_OPTION  automatically on the level of OPTIONGROUP in case INPUT or TEXTAREA
                                            selectedGroup.ID_OPTION(result1[0].IDOPTION);
                                        }
                                        /*******************************************************************************************/
                                    }

                                    if (result.indexOf(extraData) == result.length - 1) {
                                        // -------------------
                                        if (SuccessHandler) {
                                            SuccessHandler();
                                        }
                                        // -------------------
                                    }

                                }

                                Get_Local_Options_By_IDOPTION
                                (
                                    Params_Get_Local_Options_By_IDOPTION,
                                    Get_Local_Options_By_IDOPTION_Success,
                                    null,
                                    result[i]
                                );

                            }
                        }
                        else {
                            // -------------------
                            if (SuccessHandler) {
                                SuccessHandler();
                            }
                            // -------------------
                        }
                    }


                    Get_Local_Optionsxref_By_IDOPTIONGROUP
                    (
                        Params_Get_Local_Optionsxref_By_IDOPTIONGROUP,
                        Get_Local_Optionsxref_By_IDOPTIONGROUP_Success,
                        null
                    );
                    // ---------------                



                }
            }
        };

        Get_Local_Source_By_CODE
		(
			Params_Get_Local_Source_By_CODE,
			Get_Local_Source_By_CODE_Success,
			null
        );
        // ---------------

    }
    catch (e) {
        Notify("Get_Local_Product_GroupOptions: " + e.Message);
    }
}
// ------------------


// ------------------
function Get_Local_Product_Excluded_Options(Params_Get_Local_Product_Excluded_Options, SuccessHandler, FailureHandler, extraData) {
    try {


        // ---------------
        var js_Source = null;
        // ---------------

        // ---------------
        var Params_Get_Local_Source_By_CODE = new Object();
        Params_Get_Local_Source_By_CODE.CODE = Params_Get_Local_Product_Excluded_Options.SOURCE_CODE;

        var Get_Local_Source_By_CODE_Success = function (result) {

            if (result != null) {

                if (result.length > 0) {

                    // ---------------
                    js_Source = result[0];
                    // ---------------                    

                    // ---------------
                    var Params_Get_Local_Optionsprodex_By_IDPRODUCT = new Object();
                    //Params_Get_Local_Optionsprodex_By_SOURCE_ID_IDPRODUCT.SOURCE_ID = parseInt(js_Source.SURROGATE_ID);
                    Params_Get_Local_Optionsprodex_By_IDPRODUCT.IDPRODUCT = parseInt(Params_Get_Local_Product_Excluded_Options.IDPRODUCT);

                    var Get_Local_Optionsprodex_By_IDPRODUCT_Success = function (result_Optionsprodex) {
                        //********************
                        var result = [];
                        ko.utils.arrayForEach(result_Optionsprodex, function (item) {
                            if (item.SOURCE_ID == parseInt(js_Source.SURROGATE_ID)) {
                                result.push(item);
                            }
                        });
                        //********************

                        if (result != null && result.length > 0) {

                            for (var i = 0; i < result.length; i++) {

                                // ------------------------
                                var Params_Get_Local_Options_By_IDOPTION = new Object();
                                //Params_Get_Local_Options_By_SOURCE_ID_IDOPTION.SOURCE_ID = parseInt(js_Source.SURROGATE_ID);
                                Params_Get_Local_Options_By_IDOPTION.IDOPTION = parseInt(result[i].IDOPTION);

                                var Get_Local_Options_By_IDOPTION_Success = function (result_Options, params, extraOptionProdex) {
                                    //********************
                                    var result1 = [];
                                    ko.utils.arrayForEach(result_Options, function (item) {
                                        if (item.SOURCE_ID == parseInt(js_Source.SURROGATE_ID)) {
                                            result1.push(item);
                                        }
                                    });
                                    //********************

                                    if (result1.length > 0) {
                                        var js_Entry = ko.mapping.fromJS(result1[0]);
                                        extraData.push(js_Entry);
                                    }

                                    if (result.indexOf(extraOptionProdex) == result.length - 1) {
                                        // -------------------
                                        if (SuccessHandler) {
                                            SuccessHandler();
                                        }
                                        // -------------------
                                    }
                                };

                                Get_Local_Options_By_IDOPTION
                                (
                                    Params_Get_Local_Options_By_IDOPTION,
                                    Get_Local_Options_By_IDOPTION_Success,
                                    null,
                                    result[i]
                                );
                                // ------------------------


                            }
                        }
                        else {
                            // -------------------
                            if (SuccessHandler) {
                                SuccessHandler();
                            }
                            // -------------------
                        }
                    }

                    Get_Local_Optionsprodex_By_IDPRODUCT
                    (
                      Params_Get_Local_Optionsprodex_By_IDPRODUCT,
                      Get_Local_Optionsprodex_By_IDPRODUCT_Success,
                      null
                    );
                    // ---------------
                }
            }
        };

        Get_Local_Source_By_CODE
		(
			Params_Get_Local_Source_By_CODE,
			Get_Local_Source_By_CODE_Success,
			null
        );
        // ---------------

    }
    catch (e) {
        Notify("Get_Local_Product_Excluded_Options: " + e.Message);
    }
}
// ------------------




// ------------------
function Get_Local_Product_Addons(Params_Get_Local_Product_Addons, SuccessHandler, FailureHandler, extraData) {
    try {

        // ---------------
        var js_Source = null;
        // ---------------

        // ---------------
        var Params_Get_Local_Source_By_CODE = new Object();
        Params_Get_Local_Source_By_CODE.CODE = Params_Get_Local_Product_Addons.SOURCE_CODE;

        var Get_Local_Source_By_CODE_Success = function (result) {

            if (result != null) {

                if (result.length > 0) {

                    // ---------------
                    js_Source = result[0];
                    // ---------------

                    // Get Add on Categories
                    // ---------------
                    var Params_Get_Local_Addoncategories_products_By_IDPRODUCT = new Object();
                    //Params_Get_Local_Addoncategories.SOURCE_ID = parseInt(js_Source.SURROGATE_ID);
                    Params_Get_Local_Addoncategories_products_By_IDPRODUCT.IDPRODUCT = Params_Get_Local_Product_Addons.IDPRODUCT;

                    var Get_Local_Addoncategories_products_By_IDPRODUCT_Success = function (result_Addoncategories_products) {
                        //********************
                        var result = [];
                        ko.utils.arrayForEach(result_Addoncategories_products, function (item) {
                            if (item.SOURCE_ID == parseInt(js_Source.SURROGATE_ID)) {
                                result.push(item);
                            }
                        });
                        //********************

                        if (result != null && result.length > 0) {
                            for (var i = 0; i < result.length; i++) {

                                // ----------------
                                var Params_Get_Local_Categories_products_By_IDCATEGORY = new Object();
                                //Params_Get_Local_Categories_products_By_SOURCE_ID_IDCATEGORY.SOURCE_ID = parseInt(js_Source.SURROGATE_ID);
                                Params_Get_Local_Categories_products_By_IDCATEGORY.IDCATEGORY = parseInt(result[i].IDCATEGORY);

                                var Get_Local_Categories_products_By_IDCATEGORY_Success = function (result_Categories_products) {
                                    //********************
                                    var result1 = [];
                                    ko.utils.arrayForEach(result_Categories_products, function (item) {
                                        if (item.SOURCE_ID == parseInt(js_Source.SURROGATE_ID)) {
                                            result1.push(item);
                                        }
                                    });
                                    //********************

                                    if (result1 != null && result1.length > 0) {
                                        for (var i = 0; i < result1.length; i++) {

                                            // Get Add on products
                                            // ----------------
                                            var Params_Get_Local_Products_By_IDPRODUCT = new Object();
                                            //Params_Get_Local_Products_By_SOURCE_ID_IDPRODUCT_ACTIVE.SOURCE_ID = parseInt(js_Source.SURROGATE_ID);
                                            Params_Get_Local_Products_By_IDPRODUCT.IDPRODUCT = parseInt(result1[i].IDPRODUCT);
                                            //Params_Get_Local_Products_By_SOURCE_ID_IDPRODUCT_ACTIVE.ACTIVE = -1;

                                            var Get_Local_Products_By_IDPRODUCT_Success = function (result_Products) {
                                                //********************
                                                var result2 = [];
                                                ko.utils.arrayForEach(result_Products, function (item) {
                                                    if (item.SOURCE_ID == parseInt(js_Source.SURROGATE_ID) && item.ACTIVE == -1) {
                                                        result2.push(item);
                                                    }
                                                });
                                                //********************

                                                if (result2.length > 0) {
                                                    // -------------------
                                                    result2[0].DATA_URI = Get_Image_Url(result2[0].SMALLIMAGEURL);
                                                    var js_Entry = ko.mapping.fromJS(result2[0]);
                                                    extraData.push(js_Entry);
                                                    // -------------------                                                    
                                                }
                                            }

                                            Get_Local_Products_By_IDPRODUCT
                                            (
                                                Params_Get_Local_Products_By_IDPRODUCT,
                                                Get_Local_Products_By_IDPRODUCT_Success,
                                                null,
                                                null
                                            );
                                            // ----------------       
                                        }
                                    }
                                    else {
                                        // -------------------
                                        if (SuccessHandler) {
                                            SuccessHandler();
                                        }
                                        // -------------------
                                    }
                                };

                                Get_Local_Categories_products_By_IDCATEGORY
                                (
                                    Params_Get_Local_Categories_products_By_IDCATEGORY,
                                    Get_Local_Categories_products_By_IDCATEGORY_Success,
                                    null
                                );
                                // ----------------
                            }
                        }
                        else {
                            // -------------------
                            if (SuccessHandler) {
                                SuccessHandler();
                            }
                            // -------------------
                        }
                    };

                    Get_Local_Addoncategories_products_By_IDPRODUCT
                    (
                        Params_Get_Local_Addoncategories_products_By_IDPRODUCT,
                        Get_Local_Addoncategories_products_By_IDPRODUCT_Success,
                        null
                    );
                    // ---------------
                }
                else {
                    // -------------------
                    if (SuccessHandler) {
                        SuccessHandler();
                    }
                    // -------------------
                }
            }
        };

        Get_Local_Source_By_CODE
		(
			Params_Get_Local_Source_By_CODE,
			Get_Local_Source_By_CODE_Success,
			null
        );
        // ---------------

    }
    catch (e) {
        Notify("Get_Local_Product_Addons:" + e.message);
    }
}
// ------------------



// ------------------
function Initialize_Card_Head(Params_Initialize_Card_Head, SuccessHandler, FailureHandler) {
    try {

        // ---------------
        var js_Source = null;
        // ---------------

        // ---------------
        var Params_Get_Local_Source_By_CODE = new Object();
        Params_Get_Local_Source_By_CODE.CODE = Params_Initialize_Card_Head.SOURCE_CODE;

        var Get_Local_Source_By_CODE_Success = function (result) {

            if (result != null) {

                if (result.length > 0) {

                    // ---------------
                    js_Source = result[0];
                    // ---------------

                    // handle Cart existence
                    // ---------------
                    var Params_Get_Local_Carthead_By_OWNER_ID = new Object();
                    Params_Get_Local_Carthead_By_OWNER_ID.OWNER_ID = 1;

                    var Get_Local_Carthead_By_OWNER_ID_Success = function (result) {
                        if (result.length == 0) {

                            // -----------------
                            var Carthead = new Object();
                            Carthead.CARTHEAD_ID = -1;
                            Carthead.SOURCE_ID = parseInt(js_Source.SURROGATE_ID);
                            Carthead.ENTRY_USER_ID = 1;
                            Carthead.ENTRY_DATE = $.format.date(new Date(), "yyyy-MM-dd");
                            Carthead.OWNER_ID = 1;
                            Carthead.IDORDER = -1;
                            Carthead.SUBTOTAL = 0;
                            Carthead.TOTAL = 0;
                            Carthead.DISCCODE = '';
                            Carthead.DISCPERC = 0;
                            Carthead.DISCTOTAL = 0;
                            Carthead.IDCUST = -1;
                            Carthead.ORDERDATE = $.format.date(new Date(), "yyyy-MM-dd HH:mm:ss"); ;
                            Carthead.ORDERDATEINT = $.format.date(new Date(), "yyyyMMddHHmmss");
                            Carthead.RANDOMKEY = '';
                            Carthead.TAXTOTAL = 0;
                            Carthead.SHIPMENTTOTAL = 0;
                            Carthead.SHIPMENTMETHOD = '';
                            Carthead.NAME = '';
                            Carthead.LASTNAME = '';
                            Carthead.CUSTOMERCOMPANY = '';
                            Carthead.PHONE = '';
                            Carthead.EMAIL = '';
                            Carthead.ADDRESS = '';
                            Carthead.CITY = '';
                            Carthead.LOCSTATE = '';
                            Carthead.LOCCOUNTRY = '';
                            Carthead.ZIP = '';
                            Carthead.SHIPPINGNAME = '';
                            Carthead.SHIPPINGLASTNAME = '';
                            Carthead.SHIPPINGADDRESS = '';
                            Carthead.SHIPPINGCITY = '';
                            Carthead.SHIPPINGLOCSTATE = '';
                            Carthead.SHIPPINGLOCCOUNTRY = '';
                            Carthead.SHIPPINGZIP = '-';
                            Carthead.PAYMENTTYPE = '';
                            Carthead.CARDTYPE = '';
                            Carthead.CARDNUMBER = '';
                            Carthead.CARDEXPMONTH = '';
                            Carthead.CARDEXPYEAR = '';
                            Carthead.CARDVERIFY = '';
                            Carthead.CARDNAME = '';
                            Carthead.GENERALCOMMENTS = '';
                            Carthead.ORDERSTATUS = 'U';
                            Carthead.AUDITINFO = '';
                            Carthead.STORECOMMENTS = '';
                            Carthead.STORECOMMENTSPRIV = '';
                            Carthead.ADJUSTAMOUNT = 0;
                            Carthead.ADJUSTREASON = '';
                            Carthead.TAXEXEMPT = 'N';
                            Carthead.SHIPPINGPHONE = '';
                            Carthead.HANDLINGFEETOTAL = 0;
                            Carthead.IDAFFILIATE = -1;
                            Carthead.COMMPERC = 0;
                            Carthead.OTHERFEETOTAL = 0;
                            Carthead.SHIPPINGDATE = '';
                            Carthead.FROM_APP = 1;
                                                                                    
                            var Edit_Local_Carthead_Success = function (i_Carthead, js_Edit_Mode) {                                
                                Notify("Cart Head Created Successfully");
                                SuccessHandler(i_Carthead);
                            }

                            var Edit_Local_Carthead_Failure = function () {
                                Notify("Error while trying to create carthead entry");
                            }

                            Edit_Local_Carthead
                            (
                                Carthead,
                                Edit_Local_Carthead_Success,
                                Edit_Local_Carthead_Failure
                            );

                        }
                        else {
                            SuccessHandler(result[0]);
                        }
                    };

                    Get_Local_Carthead_By_OWNER_ID
                    (
                      Params_Get_Local_Carthead_By_OWNER_ID,
                      Get_Local_Carthead_By_OWNER_ID_Success,
                      null
                    );
                    // ---------------


                }
            }
        };

        Get_Local_Source_By_CODE
		(
			Params_Get_Local_Source_By_CODE,
			Get_Local_Source_By_CODE_Success,
			null
        );
        // ---------------

    }
    catch (e) {
        Notify("Initialize_Card_Head:" + e.message);
    }
}
// ------------------


// ------------------
function Add_To_Cart(Params_Add_To_Cart, SuccessHandler, FailureHandler, extraData) {
    try {        
        // ---------------
        var js_Source = null;
        // ---------------

        // ---------------
        var Params_Get_Local_Source_By_CODE = new Object();
        Params_Get_Local_Source_By_CODE.CODE = Params_Add_To_Cart.SOURCE_CODE;

        var Get_Local_Source_By_CODE_Success = function (result) {
            
            if (result != null) {

                if (result.length > 0) {

                    // ---------------
                    js_Source = result[0];
                    // ---------------

                    // ---------------
                    if (Params_Add_To_Cart.IDPRODUCT_LIST != null && Params_Add_To_Cart.IDPRODUCT_LIST.length > 0) {
                        for (var i = 0; i < Params_Add_To_Cart.IDPRODUCT_LIST.length; i++) {

                            var Params_Get_Local_Product_By_IDPRODUCT = new Object();
                            //Params_Get_Local_Product.SOURCE_ID = parseInt(js_Source.SURROGATE_ID);
                            Params_Get_Local_Product_By_IDPRODUCT.IDPRODUCT = parseInt(Params_Add_To_Cart.IDPRODUCT_LIST[i]);

                            var Get_Local_Products_By_IDPRODUCT_Success = function (result_products) {
                                //********************
                                var result = [];
                                ko.utils.arrayForEach(result_products, function (item) {
                                    if (item.SOURCE_ID == parseInt(js_Source.SURROGATE_ID)) {
                                        result.push(item);
                                    }
                                });
                                //********************

                                if (result.length > 0) {

                                    // ---------------
                                    var Params_Get_Local_Cartrows_By_IDPRODUCT = new Object();
                                    //Params_Get_Local_Cartrows.SOURCE_ID = parseInt(js_Source.SURROGATE_ID);
                                    Params_Get_Local_Cartrows_By_IDPRODUCT.IDPRODUCT = parseInt(result[0].IDPRODUCT);

                                    var Get_Local_Cartrows_By_IDPRODUCT_Success = function (result_cartRows, params, extraData) {
                                        //********************
                                        var result = [];
                                        ko.utils.arrayForEach(result_cartRows, function (item) {
                                            if (item.SOURCE_ID == parseInt(js_Source.SURROGATE_ID)) {
                                                result.push(item);
                                            }
                                        });
                                        //********************

                                        if (result.length == 0) { // To Avoid creating duplication of IDPRODUCT
                                            // -------------
                                            Insert_Cartrow(extraData, js_Source, Params_Add_To_Cart.IDPRODUCT_LIST, SuccessHandler);
                                            // -------------
                                        }
                                        else {
                                            // INITIAL PRODUCT NOT ADD_ON                                            
                                            if (Params_Add_To_Cart.IDPRODUCT_LIST.indexOf(extraData.IDPRODUCT) == 0) {
                                                //var Cartrow;
                                                var arr_IDOPTIONs_TextVal = [];
                                                var Cartrowsoptions_Match = false;

                                                // Gethering selected OPTIONS and put them in array //
                                                /******************************************************************************/
                                                if (MyApp_VM.PRODUCT_OPTIONSGROUPS().length > 0) {
                                                    ko.utils.arrayForEach(MyApp_VM.PRODUCT_OPTIONSGROUPS(), function (Item_OptionGroup) {
                                                        var Flg_OptionSelected_Type;

                                                        if (Item_OptionGroup.ID_OPTION() != null && Item_OptionGroup.ID_OPTION() != '') {
                                                            // ------------------------------------
                                                            if ((Item_OptionGroup.OPTIONTYPE() == 'A' || Item_OptionGroup.OPTIONTYPE() == 'T') && $.trim(Item_OptionGroup.TXT_VALUE()) != '') {
                                                                Flg_OptionSelected_Type = "TEXT";
                                                            }
                                                            else if (Item_OptionGroup.OPTIONTYPE() == 'S' || Item_OptionGroup.OPTIONTYPE() == 'R') {
                                                                Flg_OptionSelected_Type = "ID";
                                                            }
                                                            // ------------------------------------

                                                            if (Flg_OptionSelected_Type != null) {
                                                                var Option_Match = ko.utils.arrayFirst(MyApp_VM.PRODUCT_OPTIONS(), function (Item_Option) {
                                                                    return Item_Option.IDOPTION() == Item_OptionGroup.ID_OPTION();
                                                                });

                                                                if (Option_Match) {
                                                                    var OPTION_ID = Option_Match.IDOPTION();
                                                                    var OPTION_TXT = Flg_OptionSelected_Type == "TEXT" ? $.trim(Item_OptionGroup.TXT_VALUE()) : $.trim(Option_Match.OPTIONDESCRIP());

                                                                    arr_IDOPTIONs_TextVal.push(OPTION_ID + ':' + OPTION_TXT);
                                                                }
                                                            }
                                                        }
                                                    });
                                                }
                                                /******************************************************************************/

                                                var max = result.length - 1;

                                                for (var k = 0; k < result.length; k++) {
                                                    // -------------
                                                    var Params_Get_Local_Cartrowsoptions_By_IDCARTROW = new Object();
                                                    //Params_Get_Local_Cartrowsoptions_By_SOURCE_ID_IDORDER_IDCARTROW.SOURCE_ID = parseInt(js_Source.SURROGATE_ID);
                                                    //Params_Get_Local_Cartrowsoptions_By_SOURCE_ID_IDORDER_IDCARTROW.IDORDER = -1;
                                                    Params_Get_Local_Cartrowsoptions_By_IDCARTROW.IDCARTROW = result[k].CARTROWS_ID;

                                                    var Get_Local_Cartrowsoptions_By_IDCARTROW_Success = function (result_cartRowOptions, p, Count) {
                                                        //********************
                                                        var result = [];
                                                        ko.utils.arrayForEach(result_cartRowOptions, function (item) {
                                                            if (item.SOURCE_ID == parseInt(js_Source.SURROGATE_ID) && item.IDORDER == -1) {
                                                                result.push(item);
                                                            }
                                                        });
                                                        //********************

                                                        var _Cartrowsoptions = ko.mapping.fromJS([]);
                                                        var arr_Cartrowoption_IDOPTIONs_TextVal = [];

                                                        if (result != null) {
                                                            //var Cartrow = result[k];
                                                            //var _Cartrowsoptions = ko.mapping.fromJS([]);
                                                            //var arr_Cartrowoption_IDOPTIONs_TextVal = [];

                                                            ko.mapping.fromJS(result, _Cartrowsoptions);
                                                            ko.utils.arrayForEach(_Cartrowsoptions(), function (Item_Cartrowoption) {
                                                                var OPTION_ID = Item_Cartrowoption.IDOPTION();
                                                                var OPTION_TXT = $.trim(Item_Cartrowoption.OPTIONDESCRIP());
                                                                arr_Cartrowoption_IDOPTIONs_TextVal.push(OPTION_ID + ':' + OPTION_TXT);
                                                            });
                                                            //console.log(JSON.stringify(arr_Cartrowoption_IDOPTIONs_TextVal) + ' ~' + JSON.stringify(arr_IDOPTIONs_TextVal));
                                                            if (arr_Cartrowoption_IDOPTIONs_TextVal.length == arr_IDOPTIONs_TextVal.length) {
                                                                if (arr_Cartrowoption_IDOPTIONs_TextVal.length > 0) {
                                                                    for (var j = 0; j < arr_Cartrowoption_IDOPTIONs_TextVal.length; j++) {
                                                                        if ($.inArray(arr_IDOPTIONs_TextVal[j], arr_Cartrowoption_IDOPTIONs_TextVal) == -1) {
                                                                            break;
                                                                        }
                                                                        else {
                                                                            if (j == arr_Cartrowoption_IDOPTIONs_TextVal.length - 1) {
                                                                                Cartrowsoptions_Match = true;
                                                                            }
                                                                        }
                                                                    }
                                                                }
                                                                else {
                                                                    Cartrowsoptions_Match = true;
                                                                }
                                                            }
                                                        }
                                                        else {
                                                            if (arr_Cartrowoption_IDOPTIONs_TextVal.length == arr_IDOPTIONs_TextVal.length) {
                                                                Cartrowsoptions_Match = true;
                                                            }
                                                        }
                                                        //console.log('Match:' + Cartrowsoptions_Match);
                                                        //console.log('Count:' + Count);
                                                        //alert('Max:' + max);
                                                        if (Cartrowsoptions_Match == false && Count == max) {
                                                            // -------------
                                                            Insert_Cartrow(extraData, js_Source, Params_Add_To_Cart.IDPRODUCT_LIST, SuccessHandler);
                                                            // -------------
                                                        }
                                                        else if (Cartrowsoptions_Match == true && Count == max) {
                                                            // -------------
                                                            if (SuccessHandler != null) { SuccessHandler(); }
                                                            // -------------
                                                        }
                                                    };

                                                    Get_Local_Cartrowsoptions_By_IDCARTROW
                                                    (
                                                        Params_Get_Local_Cartrowsoptions_By_IDCARTROW,
                                                        Get_Local_Cartrowsoptions_By_IDCARTROW_Success,
                                                        null,
                                                        k
                                                    );
                                                    // -------------                                                

                                                    // -------------
                                                    //sleep(500);
                                                    // -------------                                           
                                                }
                                            }
                                            else {
                                                if (Params_Add_To_Cart.IDPRODUCT_LIST.indexOf(extraData.IDPRODUCT) == Params_Add_To_Cart.IDPRODUCT_LIST.length - 1) {
                                                    // -------------
                                                    if (SuccessHandler != null) { SuccessHandler(); }
                                                    // -------------
                                                }
                                            }
                                        }
                                    };

                                    Get_Local_Cartrows_By_IDPRODUCT
                                    (
	                                    Params_Get_Local_Cartrows_By_IDPRODUCT,
	                                    Get_Local_Cartrows_By_IDPRODUCT_Success,
	                                    null,
                                        result[0] // Product
                                     );
                                    // ---------------

                                }
                            }

                            Get_Local_Products_By_IDPRODUCT
                            (
                                Params_Get_Local_Product_By_IDPRODUCT,
                                Get_Local_Products_By_IDPRODUCT_Success,
                                null
                            );
                        }
                    }
                    else {
                        // -------------
                        if (SuccessHandler != null) { SuccessHandler(); }
                        // -------------
                    }
                    // ---------------                   
                }
            }
        };

        Get_Local_Source_By_CODE
		(
			Params_Get_Local_Source_By_CODE,
			Get_Local_Source_By_CODE_Success,
			null
        );
        // ---------------

    }
    catch (e) {
        Notify("Add_To_Cart:" + e.message);
    }
}
// ------------------

// ------------------
function Insert_Cartrow(extraData, js_Source, IDPRODUCT_LIST, SuccessHandler) {
    try {
        // Get product's Supplier ID and commission rates    
        // ------------------------------
        var Params_Get_Local_Consigncomm_By_IDPRODUCT = new Object();
        //Params_Get_Local_Consigncomm_By_SOURCE_ID_IDPRODUCT_DISCFROMQTY.SOURCE_ID = parseInt(js_Source.SURROGATE_ID);
        Params_Get_Local_Consigncomm_By_IDPRODUCT.IDPRODUCT = parseInt(extraData.IDPRODUCT);
        //Params_Get_Local_Consigncomm_By_SOURCE_ID_IDPRODUCT_DISCFROMQTY.DISCFROMQTY = 1;

        var Get_Local_Consigncomm_By_IDPRODUCT_Success = function (result_consignComms) {
            //Initialize External variables
            var js_idconsigncomm = 0;
            var js_consignFlat = 0;
            var js_consignPerc = 0;
            var js_consignAmt = 0;

            //********************
            var result = [];
            ko.utils.arrayForEach(result_consignComms, function (item) {
                if (item.SOURCE_ID == parseInt(js_Source.SURROGATE_ID) && item.DISCFROMQTY == 1) {
                    result.push(item);
                }
            });
            //********************

            if (result != null && result.length > 0) {
                js_idconsigncomm = result[0].IDCONSIGN;
                js_consignFlat = result[0].DISCAMT;
                js_consignPerc = result[0].DISCPERC;

                if (js_consignFlat == null) {
                    js_consignFlat = 0;
                }
                if (js_consignPerc == null) {
                    js_consignPerc = 0;
                }

                if (js_consignPerc == 0 && js_consignFlat > 0) {
                    js_consignAmt = (js_consignFlat * 1)  // 1 = Quantity
                }
                else {
                    js_consignAmt = parseFloat(Math.round(extraData.PRICE * js_consignPerc / 100, 2) * 1);  // 1 = Quantity
                }
            }
            // #####################################################################
            // -------------
            var Cartrows = new Object();
            Cartrows.CARTROWS_ID = -1;
            Cartrows.IDORDER = -1;
            Cartrows.IDPRODUCT = parseInt(extraData.IDPRODUCT);
            Cartrows.SKU = extraData.SKU;
            Cartrows.QUANTITY = 1;
            Cartrows.UNITPRICE = extraData.PRICE;
            Cartrows.UNITWEIGHT = extraData.WEIGHT
            Cartrows.DESCRIPTION = extraData.DESCRIPTION;
            Cartrows.TAXEXEMPT = extraData.TAXEXEMPT;
            Cartrows.SOURCE_ID = parseInt(js_Source.SURROGATE_ID);
            Cartrows.ENTRY_USER_ID = 1;
            Cartrows.ENTRY_DATE = $.format.date(new Date(), "yyyy-MM-dd");
            Cartrows.OWNER_ID = 1;
            Cartrows.DOWNLOADCOUNT = 0;
            Cartrows.DOWNLOADDATE = '';
            Cartrows.IDDISCPROD = -1;
            Cartrows.DISCAMT = 0;
            Cartrows.IDCONSIGNCOMM = js_idconsigncomm;
            Cartrows.CONSIGNAMT = js_consignAmt;
            Cartrows.CONSIGNPAIDDATE = '';
            Cartrows.CONSIGNPAYPAL = '';
            Cartrows.CONSIGNFLAT = js_consignFlat;
            Cartrows.CONSIGNPERC = js_consignPerc;
            Cartrows.IDCARTROW = -1;
            // -------------

            var Edit_Local_Cartrows_Success = function (i_Cartrows, js_Edit_Mode, extraData) {
                // INITIAL PRODUCT NOT ADD_ON                                            
                if (IDPRODUCT_LIST.indexOf(extraData.IDPRODUCT) == 0) {
                    // INSERT OPTIONGROUPS IF THEY EXIST AND FILLED
                    // -------------
                    if (MyApp_VM.PRODUCT_OPTIONSGROUPS().length > 0) {
                        var k = 0;
                        ko.utils.arrayForEach(MyApp_VM.PRODUCT_OPTIONSGROUPS(), function (Item_OptionGroup) {
                            k += 1;
                            var Flg_OptionSelected_Type;

                            if (Item_OptionGroup.ID_OPTION() != null && Item_OptionGroup.ID_OPTION() != '') {
                                // ------------------------------------
                                if ((Item_OptionGroup.OPTIONTYPE() == 'A' || Item_OptionGroup.OPTIONTYPE() == 'T') && $.trim(Item_OptionGroup.TXT_VALUE()) != '') {
                                    Flg_OptionSelected_Type = "TEXT";
                                }
                                else if (Item_OptionGroup.OPTIONTYPE() == 'S' || Item_OptionGroup.OPTIONTYPE() == 'R') {
                                    Flg_OptionSelected_Type = "ID";
                                }
                                // ------------------------------------

                                if (Flg_OptionSelected_Type != null) {
                                    var Option_Match = ko.utils.arrayFirst(MyApp_VM.PRODUCT_OPTIONS(), function (Item_Option) {
                                        return Item_Option.IDOPTION() == Item_OptionGroup.ID_OPTION();
                                    });

                                    if (Option_Match) {
                                        // ------------------
                                        var Cartrowsoptions = new Object();
                                        Cartrowsoptions.IDORDER = -1;
                                        Cartrowsoptions.IDCARTROW = i_Cartrows.CARTROWS_ID;
                                        Cartrowsoptions.IDOPTION = Option_Match.IDOPTION();
                                        Cartrowsoptions.OPTIONPRICE = Option_Match.PRICETOADD();
                                        Cartrowsoptions.OPTIONWEIGHT = Option_Match.WEIGHTTOADD();
                                        Cartrowsoptions.OPTIONDESCRIP = Flg_OptionSelected_Type == "TEXT" ? Item_OptionGroup.OPTIONGROUPDESC() + ': ' + $.trim(Item_OptionGroup.TXT_VALUE()) : $.trim(Option_Match.OPTIONDESCRIP());
                                        Cartrowsoptions.TAXEXEMPT = Option_Match.TAXEXEMPT();
                                        Cartrowsoptions.SOURCE_ID = parseInt(js_Source.SURROGATE_ID);
                                        Cartrowsoptions.ENTRY_USER_ID = 1;
                                        Cartrowsoptions.ENTRY_DATE = $.format.date(new Date(), "yyyy-MM-dd");
                                        Cartrowsoptions.OWNER_ID = 1;
                                        Cartrowsoptions.IDCARTROWOPTION = -1;
                                        Cartrowsoptions.CARTROWSOPTIONS_ID = -1;
                                        // ------------------
                                    }

                                    var Edit_Local_Cartrowsoptions_Success = function (result, params, CountRowsOptions) {
                                        if (MyApp_VM.PRODUCT_OPTIONSGROUPS().length == CountRowsOptions
                                    && IDPRODUCT_LIST.indexOf(extraData.IDPRODUCT) == IDPRODUCT_LIST.length - 1) {
                                            // -------------
                                            if (SuccessHandler != null) { SuccessHandler(); }
                                            // -------------
                                        }
                                    };

                                    Edit_Local_Cartrowsoptions(Cartrowsoptions, Edit_Local_Cartrowsoptions_Success, null, k);
                                }
                                else {
                                    if (MyApp_VM.PRODUCT_OPTIONSGROUPS().length == k
                                    && IDPRODUCT_LIST.indexOf(extraData.IDPRODUCT) == IDPRODUCT_LIST.length - 1) {
                                        // -------------
                                        if (SuccessHandler != null) { SuccessHandler(); }
                                        // -------------
                                    }
                                }
                            }
                            else {
                                if (MyApp_VM.PRODUCT_OPTIONSGROUPS().length == k
                                    && IDPRODUCT_LIST.indexOf(extraData.IDPRODUCT) == IDPRODUCT_LIST.length - 1) {
                                    // -------------
                                    if (SuccessHandler != null) { SuccessHandler(); }
                                    // -------------
                                }
                            }
                        });
                    }
                    else {
                        if (IDPRODUCT_LIST.indexOf(extraData.IDPRODUCT) == IDPRODUCT_LIST.length - 1) {
                            // -------------
                            if (SuccessHandler != null) { SuccessHandler(); }
                            // -------------
                        }
                    }
                }
                else {
                    if (IDPRODUCT_LIST.indexOf(extraData.IDPRODUCT) == IDPRODUCT_LIST.length - 1) {
                        // -------------
                        if (SuccessHandler != null) { SuccessHandler(); }
                        // -------------
                    }
                }
                // -------------

                // -------------
                //extraData == product
                // -------------

                // -------------
                Notify("Cartrow created successfully");
                // -------------                                                      
            }
            var Edit_Local_Cartrows_Failure = function () { }

            Edit_Local_Cartrows
	        (
		        Cartrows,
		        Edit_Local_Cartrows_Success,
		        Edit_Local_Cartrows_Failure,
		        extraData // Selected Product
	        );
            // #####################################################################
        };
        Get_Local_Consigncomm_By_IDPRODUCT
        (
            Params_Get_Local_Consigncomm_By_IDPRODUCT,
            Get_Local_Consigncomm_By_IDPRODUCT_Success,
            null,
            null
        )
        // ------------------------------
    }
    catch (e) {
        Notify("Add_To_Cart:" + e.message);
    }
}
// ------------------

// ------------------
function Remove_From_Cart(Params_Remove_From_Cart, SuccessHandler, FailureHandler, extraData) {
    try {
        
        // ---------------
        var js_Source = null;
        // ---------------

        // ---------------
        var Params_Get_Local_Source_By_CODE = new Object();
        Params_Get_Local_Source_By_CODE.CODE = Params_Remove_From_Cart.SOURCE_CODE;

        var Get_Local_Source_By_CODE_Success = function (result) {

            if (result != null) {

                if (result.length > 0) {

                    // ---------------
                    js_Source = result[0];
                    // ---------------

                    // ---------------
                    // Delete_Local_Cartrows_By_SOURCE_ID_IDPRODUCT
                    var Params_Delete_Local_Cartrows_By_CARTROWS_ID = new Object();
                    Params_Delete_Local_Cartrows_By_CARTROWS_ID.CARTROWS_ID = parseInt(Params_Remove_From_Cart.CARTROWS_ID);
                    //var Params_Delete_Local_Cartrows = new Object();
                    //Params_Delete_Local_Cartrows.SOURCE_ID = parseInt(js_Source.SURROGATE_ID);
                    //Params_Delete_Local_Cartrows.IDPRODUCT = parseInt(Params_Remove_From_Cart.IDPRODUCT);

                    //var Delete_Local_Cartrows_By_SOURCE_ID_IDPRODUCT_Success = function () {
                    var Delete_Local_Cartrows_By_CARTROWS_ID_Success = function () {

                        // -------------
                        Notify("CartRows Deleted Successfully");
                        // -------------

                        // -------------
                        var Params_Calculate_Cart = new Object();
                        Params_Calculate_Cart.SOURCE_CODE = js_Source.CODE;
                        var Calculate_Cart_Success = function (result) {
                            SuccessHandler(extraData);
                        };
                        Calculate_Cart
                        (
                            Params_Calculate_Cart,
                            Calculate_Cart_Success,
                            null
                        );
                        // -------------

                        // -------------                        
                        //SuccessHandler(extraData);
                        // -------------
                    }

                    //var Delete_Local_Cartrows_By_SOURCE_ID_IDPRODUCT_Failure = function () {
                    var Delete_Local_Cartrows_By_CARTROWS_ID_Failure = function () {
                        Notify("Error while deleting CartRows entry");
                    }

                    Delete_Local_Cartrows_By_CARTROWS_ID
                    (
                        Params_Delete_Local_Cartrows_By_CARTROWS_ID,
                        Delete_Local_Cartrows_By_CARTROWS_ID_Success,
                        Delete_Local_Cartrows_By_CARTROWS_ID_Failure
                    )
                    // ---------------

                    // ---------------
                    var Params_Delete_Local_Cartrowsoptions_By_IDCARTROW = new Object();
                    //Params_Delete_Local_Cartrowsoptions_By_SOURCE_ID_IDORDER_IDCARTROW.SOURCE_ID = parseInt(js_Source.SURROGATE_ID);
                    //Params_Delete_Local_Cartrowsoptions_By_SOURCE_ID_IDORDER_IDCARTROW.IDORDER = -1;
                    Params_Delete_Local_Cartrowsoptions_By_IDCARTROW.IDCARTROW = parseInt(Params_Remove_From_Cart.CARTROWS_ID);
                    
                    Delete_Local_Cartrowsoptions_By_IDCARTROW
                    (
                        Params_Delete_Local_Cartrowsoptions_By_IDCARTROW,
                        null,
                        null
                    )
                    // ---------------
                }
            }
        };

        Get_Local_Source_By_CODE
		(
			Params_Get_Local_Source_By_CODE,
			Get_Local_Source_By_CODE_Success,
			null
        );
        // ---------------

    }
    catch (e) {
        Notify("Remove_From_Cart:" + e.message);
    }
}
// ------------------


// ------------------
function Update_Cart(Params_Update_Cart, SuccessHandler, FailureHandler, extraData) {
    try {

        // ---------------
        var js_Source = null;
        // ---------------

        // ---------------
        var Params_Get_Local_Source_By_CODE = new Object();
        Params_Get_Local_Source_By_CODE.CODE = Params_Update_Cart.SOURCE_CODE;

        var Get_Local_Source_By_CODE_Success = function (result) {

            if (result != null) {

                if (result.length > 0) {

                    // ---------------
                    js_Source = result[0];
                    // ---------------

                    // ---------------
                    var Params_Get_Local_Cartrows_By_IDPRODUCT = new Object();
                    //Params_Get_Local_Cartrows.SOURCE_ID = parseInt(js_Source.SURROGATE_ID);
                    Params_Get_Local_Cartrows_By_IDPRODUCT.IDPRODUCT = parseInt(Params_Update_Cart.IDPRODUCT);

                    var Get_Local_Cartrows_By_IDPRODUCT_Success = function (result) {
                        if (result != null && result.length > 0) {

                            for (var i = 0; i < result.length; i++) {

                                // ---------------------                              
                                if (result[i].SOURCE_ID != parseInt(js_Source.SURROGATE_ID)) {
                                    continue;
                                }
                                // ---------------------

                                // -------------------------
                                var js_CartRows = result[i];
                                js_CartRows.QUANTITY = Params_Update_Cart.QUANTITY;
                                js_CartRows.CONSIGNAMT = js_CartRows.CONSIGNFLAT * Params_Update_Cart.QUANTITY;

                                var Edit_Local_CartRows_Success = function () {
                                    // Calculate Carthead
                                    // -------------
                                    var Params_Calculate_Cart = new Object();
                                    Params_Calculate_Cart.SOURCE_CODE = js_Source.CODE;
                                    var Calculate_Cart_Success = function (result) {
                                        if (SuccessHandler) {
                                            SuccessHandler();
                                        }
                                    };
                                    Calculate_Cart
                                        (
                                            Params_Calculate_Cart,
                                            Calculate_Cart_Success,
                                            null
                                        );
                                    // -------------
                                }

                                Edit_Local_Cartrows
                                (
                                    js_CartRows,
                                    Edit_Local_CartRows_Success,
                                    null
                                );
                                // -------------------------

                            } // End for
                        } // End if
                    };

                    Get_Local_Cartrows_By_IDPRODUCT
                    (
                        Params_Get_Local_Cartrows_By_IDPRODUCT,
                        Get_Local_Cartrows_By_IDPRODUCT_Success,
                        null
                    );
                    // ---------------


                }
            }
        };

        Get_Local_Source_By_CODE
		(
			Params_Get_Local_Source_By_CODE,
			Get_Local_Source_By_CODE_Success,
			null
        );
        // ---------------

    }
    catch (e) {
        Notify("Update_Cart:" + e.message);
    }
}
// ------------------


// ------------------
function Calculate_Cart(Params_Calculate_Cart, SuccessHandler, FailureHandler, extraData) {
    try {

        // ---------------
        var js_Source = null;
        // ---------------

        // ---------------
        var js_CartHead = null;
        // ---------------

        // ---------------
        var Params_Get_Local_Source_By_CODE = new Object();
        Params_Get_Local_Source_By_CODE.CODE = Params_Calculate_Cart.SOURCE_CODE;

        var Get_Local_Source_By_CODE_Success = function (result) {

            if (result != null) {

                if (result.length > 0) {

                    // ---------------
                    js_Source = result[0];
                    // ---------------

                    // Get Cart (Only one cart can exist in a local DB)
                    // ---------------
                    var Params_Get_Local_Carthead = new Object();
                    Params_Get_Local_Carthead.OWNER_ID = 1;

                    var Get_Local_Carthead_By_OWNER_ID_Success = function (result) {
                        if (result.length > 0) {

                            // ---------------
                            js_CartHead = result[0];
                            js_CartHead.SUBTOTAL = 0;
                            // ---------------

                            // Get all available CartRows entries
                            // ---------------
                            var Params_Get_Local_Cartrows_By_OWNER_ID = new Object();
                            Params_Get_Local_Cartrows_By_OWNER_ID.OWNER_ID = 1;

                            var Get_Local_Cartrows_By_OWNER_ID_Success = function (result) {
                                if (result != null) {                                    
                                    // --------------                                   
                                    for (var i = 0; i < result.length; i++) {
                                        js_CartHead.SUBTOTAL += result[i].QUANTITY * result[i].UNITPRICE;
                                    }
                                    // --------------

                                    // Calculate DiscTotal
                                    // --------------
                                    js_CartHead.DISCTOTAL = js_CartHead.SUBTOTAL * js_CartHead.DISCPERC / 100;
                                    // --------------

                                    // --------------
                                    var Edit_Local_Carthead_Success = function (result) {
                                        Notify("carthead updated successfully");                                        
                                        if (SuccessHandler) {
                                            SuccessHandler();
                                        }
                                    }

                                    var Edit_Local_Carthead_Failure = function () {
                                        Notify("Error while updating CartHead");
                                    }

                                    Edit_Local_Carthead
                                    (
                                        js_CartHead,
                                        Edit_Local_Carthead_Success,
                                        Edit_Local_Carthead_Failure
                                    );
                                    // --------------

                                }
                            }

                            Get_Local_Cartrows_By_OWNER_ID
                            (
                                Params_Get_Local_Cartrows_By_OWNER_ID,
                                Get_Local_Cartrows_By_OWNER_ID_Success,
                                null
                            )
                            // ---------------
                        }
                    };

                    Get_Local_Carthead_By_OWNER_ID
                    (
                        Params_Get_Local_Carthead,
                        Get_Local_Carthead_By_OWNER_ID_Success,
                        null
                    );
                    // ---------------


                }
            }
        };

        Get_Local_Source_By_CODE
		(
			Params_Get_Local_Source_By_CODE,
			Get_Local_Source_By_CODE_Success,
			null
        );
        // ---------------

    }
    catch (e) {
        Notify("Calculate_Cart:" + e.message);
    }
}
// ------------------


// ------------------
function Get_Cart(Params_Get_Cart, SuccessHandler, FailureHandler, result_CartHead, result_CartRows,updateQuantityHandler) {
    try {       
        // ---------------
        var js_Source = null;
        // ---------------

        // ---------------------
        result_CartHead(null);
        result_CartRows([]);        
        // ---------------------

        // ---------------
        var js_CartHead = null;
        var js_CartRow = null;
        var js_CartRows = ko.mapping.fromJS([]);
        // ---------------

        // ---------------
        var Params_Get_Local_Source_By_CODE = new Object();
        Params_Get_Local_Source_By_CODE.CODE = Params_Get_Cart.SOURCE_CODE;

        var Get_Local_Source_By_CODE_Success = function (result) {
            if (result != null) {

                if (result.length > 0) {

                    // ---------------
                    js_Source = result[0];
                    // ---------------

                    // Get Cart (Only one cart can exist in a local DB)
                    // ---------------
                    var Params_Get_Local_Carthead = new Object();
                    Params_Get_Local_Carthead.OWNER_ID = 1;

                    var Get_Local_Carthead_By_OWNER_ID_Success = function (result) {
                        if (result.length > 0) {

                            // ---------------
                            js_CartHead = result[0];
                            // ---------------

                            // ---------------
                            result_CartHead(result[0]);
                            // ---------------           

                            if (js_CartHead.SOURCE_ID != parseInt(js_Source.SURROGATE_ID)) {
                                // ---------------
                                if (SuccessHandler) {
                                    SuccessHandler();
                                }
                                // ---------------
                                return;
                            }

                            // Get all available CartRows entries
                            // ---------------
                            var Params_Get_Local_Cartrows_By_OWNER_ID = new Object();
                            Params_Get_Local_Cartrows_By_OWNER_ID.OWNER_ID = 1;

                            var Get_Local_Cartrows_By_OWNER_ID_Success = function (result) {

                                // Reset Payment Types
                                // -------------------
                                MyApp_VM.PAYMENT_NO2CO(0);
                                MyApp_VM.PAYMENT_CASH(0);
                                MyApp_VM.CART_PAYMENT_TYPE(0);  // 0 = All Payment types accepted
                                // -------------------


                                if (result != null && result.length > 0) {
                                    var max_CartRows = result.length - 1;

                                    for (var i = 0; i < result.length; i++) {
                                        // -------------------                                         
                                        result[i].DATA_URI = "";
                                        result[i].My_Product = new Object();
                                        result[i].My_Product.STOCK = null;
                                        result[i].My_Cartrowsoptions = [];          // Append Cartrowsoptions to each Cartrow
                                        js_CartRow = ko.mapping.fromJS(result[i]);
                                        js_CartRows.push(js_CartRow);
                                        //result_CartRows.push(js_CartRow);
                                        //console.log("result_CartRows.length:" + result_CartRows().length);
                                        // ------------------- 

                                        // Get corresponding Product entry
                                        // ------------------- 
                                        var Params_Local_Products_By_IDPRODUCT = new Object();
                                        //Params_Local_Products_By_SOURCE_ID_IDPRODUCT.SOURCE_ID = parseInt(js_Source.SURROGATE_ID);
                                        Params_Local_Products_By_IDPRODUCT.IDPRODUCT = parseInt(js_CartRow.IDPRODUCT());

                                        var Get_Local_Products_By_IDPRODUCT_Success = function (result_products, params, cartRow) {
                                            // -------------------
                                            var result = [];
                                            ko.utils.arrayForEach(result_products, function (item) {
                                                if (item.SOURCE_ID = parseInt(js_Source.SURROGATE_ID)) {
                                                    result.push(item);
                                                }
                                            });

                                            if (result.length == 0) {
                                                /******************************/
                                                result_CartRows(js_CartRows());
                                                /******************************/
                                                // ---------------
                                                if (SuccessHandler) {
                                                    SuccessHandler();
                                                }
                                                // ---------------
                                                return;
                                            }

                                            // Append Product to Cartrow
                                            // -------------------                                            
                                            ko.mapping.fromJS(result[0], {}, cartRow.My_Product);
                                            // -------------------

                                            // Set Payment Type flag
                                            // -------------------
                                            if (result[0].PAYMENT == 1) {
                                                MyApp_VM.PAYMENT_NO2CO(1);
                                            }
                                            if (result[0].PAYMENT == 2) {
                                                MyApp_VM.PAYMENT_CASH(1);
                                            }
                                            // -------------------

                                            // Get Cartrow image
                                            // -------------------                                                
                                            cartRow.DATA_URI(Get_Image_Url(result[0].SMALLIMAGEURL));
                                            cartRow.QUANTITY.subscribe(function (newValue) {
                                                if ($.isNumeric(newValue) && newValue != 0) {
                                                    if (updateQuantityHandler != null) {
                                                        updateQuantityHandler(cartRow);
                                                    }
                                                }
                                                else {
                                                    cartRow.QUANTITY(1);
                                                }
                                            });
                                            // -----------------------

                                            // Get Cartrows Cartrowsoptions
                                            // -------------
                                            var Params_Get_Local_Cartrowsoptions_By_IDCARTROW = new Object();
                                            //Params_Get_Local_Cartrowsoptions_By_SOURCE_ID_IDORDER_IDCARTROW.SOURCE_ID = parseInt(js_Source.SURROGATE_ID);
                                            //Params_Get_Local_Cartrowsoptions_By_SOURCE_ID_IDORDER_IDCARTROW.IDORDER = -1;
                                            Params_Get_Local_Cartrowsoptions_By_IDCARTROW.IDCARTROW = cartRow.CARTROWS_ID();

                                            var Get_Local_Cartrowsoptions_By_IDCARTROW_Success = function (result, params, cartRow1) {
                                                //debugger;                                                
                                                if (result != null) {
                                                    ko.mapping.fromJS(result, {}, cartRow.My_Cartrowsoptions);
                                                }
                                                // ---------------

                                                if (js_CartRows.indexOf(cartRow1) == max_CartRows) {
                                                    /******************************/
                                                    result_CartRows(js_CartRows());
                                                    /******************************/
                                                    //alert("XO");
                                                    if (SuccessHandler) {
                                                        SuccessHandler();
                                                    }
                                                }
                                                // ---------------
                                            };

                                            Get_Local_Cartrowsoptions_By_IDCARTROW
                                                    (
                                                        Params_Get_Local_Cartrowsoptions_By_IDCARTROW,
                                                        Get_Local_Cartrowsoptions_By_IDCARTROW_Success,
                                                        null,
                                                        cartRow
                                                    );
                                            // -------------                                           
                                        }
                                        Get_Local_Products_By_IDPRODUCT
                                        (
                                            Params_Local_Products_By_IDPRODUCT,
                                            Get_Local_Products_By_IDPRODUCT_Success,
                                            null,
                                            js_CartRow // Cartrow
                                        );
                                        // ------------------- 
                                    }
                                }
                                else {
                                    // ---------------
                                    if (SuccessHandler) {
                                        SuccessHandler();
                                    }
                                    // ---------------
                                }
                            }

                            Get_Local_Cartrows_By_OWNER_ID
                            (
                                Params_Get_Local_Cartrows_By_OWNER_ID,
                                Get_Local_Cartrows_By_OWNER_ID_Success,
                                null
                            )
                            // ---------------
                        }
                        else {
                            // ---------------
                            if (SuccessHandler) {
                                SuccessHandler();
                            }
                            // ---------------
                        }
                    };

                    Get_Local_Carthead_By_OWNER_ID
                    (
                        Params_Get_Local_Carthead,
                        Get_Local_Carthead_By_OWNER_ID_Success,
                        null
                    );
                    // ---------------

                }
            }
        };

        Get_Local_Source_By_CODE
		(
			Params_Get_Local_Source_By_CODE,
			Get_Local_Source_By_CODE_Success,
			null
        );
        // ---------------

    }
    catch (e) {
        Notify("Get_Cart:" + e.message);
    }
}
// ------------------

// ------------------
function Get_Device_Data_By_Key(i_DATA_KEY, SuccessHandler) {
    try {
        var js_Return;
        var js_Finish = false;
        // -----------

        var Get_Local_Device_data_By_DATA_KEY_Success = function (result) {
            if (SuccessHandler) {
                SuccessHandler(result);
            }
        };
        // -----------

        // -----------
        var Params_Get_Local_Device_data_By_DATA_KEY = new Object();
        //Params_Get_Local_Device_data_By_DATA_KEY_OWNER_ID.OWNER_ID = 1;
        Params_Get_Local_Device_data_By_DATA_KEY.DATA_KEY = i_DATA_KEY

        Get_Local_Device_data_By_DATA_KEY
	    (
		 Params_Get_Local_Device_data_By_DATA_KEY,
		 Get_Local_Device_data_By_DATA_KEY_Success,
		 null
	    );
        // -----------                
    }
    catch (e) {
        Notify("Get_Device_Data_By_Key: " + e.Message);
    }
}
// ------------------

// ------------------
function Edit_Device_Data(i_DATA_KEY, i_DATA_VALUE, SuccessHandler) {
    try {

        // -----------
        var Get_Local_Device_data_By_DATA_KEY_Success = function (result) {
            
            if (result.length == 0) {

                //---------
                var Device_data = new Object();
                Device_data.DEVICE_DATA_ID = -1;
                Device_data.DATA_KEY = i_DATA_KEY;
                Device_data.DATA_VALUE = i_DATA_VALUE;
                Device_data.ENTRY_USER_ID = 1;
                Device_data.ENTRY_DATE = '2014-05-02';
                Device_data.OWNER_ID = 1;

                var Edit_Local_Device_data_Success = function (result) {
                    if (SuccessHandler) {
                        SuccessHandler();
                    }
                };
                
                Edit_Local_Device_data(Device_data, Edit_Local_Device_data_Success, function () { alert('Err'); }, null);
                //---------
            }
            else {
                var Edit_Local_Device_data_Success = function (result) {
                    if (SuccessHandler) {
                        SuccessHandler();
                    }
                };

                //---------
                result[0].DATA_VALUE = i_DATA_VALUE;
                Edit_Local_Device_data(result[0], Edit_Local_Device_data_Success, null, null);
                //---------
            }
        };
        // -----------

        // -----------
        var Params_Get_Local_Device_data_By_DATA_KEY = new Object();
        //Params_Get_Local_Device_data_By_DATA_KEY_OWNER_ID.OWNER_ID = 1;
        Params_Get_Local_Device_data_By_DATA_KEY.DATA_KEY = i_DATA_KEY;        

        Get_Local_Device_data_By_DATA_KEY
	    (
		 Params_Get_Local_Device_data_By_DATA_KEY,
		 Get_Local_Device_data_By_DATA_KEY_Success,
		 function () { alert('Error'); }
	    );
        // -----------
    }
    catch (e) {
        Notify("Edit_Device_Data: " + e.Message);
    }
}
// ------------------

// ------------------
function Delete_Device_Data_By_Key(i_DATA_KEY, SuccessHandler) {
    try {
        // ------------------------------
        var Params_Delete_Local_Device_data_By_DATA_KEY = new Object();
        Params_Delete_Local_Device_data_By_DATA_KEY.DATA_KEY = i_DATA_KEY;
        //Params_Delete_Local_Device_data_By_DATA_KEY_OWNER_ID.OWNER_ID = 1;
        
        var Delete_Local_Device_data_By_DATA_KEY_Success = function () {
            if (SuccessHandler) {
                SuccessHandler();
            }
        };

        Delete_Local_Device_data_By_DATA_KEY
        (
            Params_Delete_Local_Device_data_By_DATA_KEY,
            Delete_Local_Device_data_By_DATA_KEY_Success,
            null
        )
        // ------------------------------

    }
    catch (e) {
        Notify("Delete_Device_Data_By_Key: " + e.Message);
    }
}
// ------------------

// Get_Image_Url
// ------------------
function Get_Image_Url(i_ImageName, extraData) {
    try {
        var url;
        if (MyApp_VM.IS_CONNECTED()) {
            url = MyApp_VM.Get_StoreAdmin_ConfingItem('urlNonSSL').CONFIGVAL().replace('scripts', 'products') + MyApp_VM.ORDER_PREFIX() + '/prodimages/' + i_ImageName;
        }
        else {
            url = js_No_Image_Data_URI;
        }
        return url;
    }
    catch (e) {
        Notify("Get_Image_Url: " + e.Message);
    }
}
// ------------------