﻿// Members //
/*****************************************************/
// --------------------
var Offline = 0;
// --------------------
/*****************************************************/

// Specific page "pagebeforecreate" event //
/*****************************************************/
$(document).on("pagebeforecreate", "#pg_cart", function (event, ui) {
    $(this).on("click", "#Btn_OrderNow", function (e) {
        // Connection Check //
        // -------------------------            
        if (!jq_ConnectionExist()) {
            // Flag that we are Offline so that when we come back to Online we do a sync
            // -----------------
            Offline = 1;
            // -----------------
            return;
        }
        // -------------------------

        // Check if connection was Offline and now we are Online, sync data with server
        // -------------------------
        if (Offline == 1) {
            // ---------------------
            jq_ShowMobileLoader();
            jq_BlockUI();
            // ---------------------

            var MyPreEvent = function () {
                Notify("Pre");
            }
            var MyOfflineEvent = function () {
                _Is_Offline_Mode = true;
                Notify("You are working in offline mode");
            }
            var MyPostEventLocalDB = function () {
                Notify("MyPostEventLocalDB event fired");
            };
            var My_Extra_LocalDB_Params = [];
            var MyPostEventRemoteDB = function () {
                // Log Sync time
                // ---------------                                    
                Edit_Device_Data("LAST_SYNC_TIME", new Date().getTime());
                // ---------------

                //---------
                Offline = 0;
                //---------

                var max_CartRows_Count = MyApp_VM.CARTROWS().length;
                var arr_ProductChanges = [];
                var Count = 0;

                ko.utils.arrayForEach(MyApp_VM.CARTROWS(), function (Item_Cartrow) {
                    // Get corresponding Product entry
                    // ------------------- 
                    var Params_Local_Products_By_SOURCE_ID_IDPRODUCT = new Object();
                    Params_Local_Products_By_SOURCE_ID_IDPRODUCT.SOURCE_ID = parseInt(MyApp_VM.SELECTED_SOURCE().SURROGATE_ID());
                    Params_Local_Products_By_SOURCE_ID_IDPRODUCT.IDPRODUCT = parseInt(Item_Cartrow.IDPRODUCT());

                    var Get_Local_Products_By_SOURCE_ID_IDPRODUCT_Success = function (result, params, cartRow) {
                        // -------------------                        
                        if (result.length > 0) {
                            var js_Product = result[0];

                            if (js_Product.STOCK == 0) {
                                // @@@@@@@@@@@@@@@@@@
                                var Params_Delete_Local_Cartrows_By_CARTROWS_ID = new Object();
                                Params_Delete_Local_Cartrows_By_CARTROWS_ID.CARTROWS_ID = parseInt(cartRow.CARTROWS_ID());

                                var Delete_Local_Cartrows_By_CARTROWS_ID_Success = function () {
                                    // -----------
                                    arr_ProductChanges.push('* ' + cartRow.DESCRIPTION() + ': Removed (Online Stock = 0)');
                                    // -----------

                                    // Increment Count
                                    // -----------
                                    Count += 1;
                                    // -----------

                                    // ----------------
                                    if (Count == max_CartRows_Count) {
                                        Display_Cart_Changes(arr_ProductChanges);
                                    }
                                    // ----------------
                                };

                                Delete_Local_Cartrows_By_CARTROWS_ID
                                (
                                    Params_Delete_Local_Cartrows_By_CARTROWS_ID,
                                    Delete_Local_Cartrows_By_CARTROWS_ID_Success,
                                    null,
                                    null
                                )
                                // @@@@@@@@@@@@@@@@@@
                            }
                            else if (js_Product.STOCK < cartRow.QUANTITY()) {
                                // ##################
                                var js_Cartrow = ko.mapping.toJS(cartRow);
                                js_Cartrow.QUANTITY = js_Product.STOCK;
                                js_Cartrow.CONSIGNAMT = js_Cartrow.CONSIGNFLAT * js_Cartrow.QUANTITY;

                                var Edit_Local_CartRows_Success = function (result, param, extraData) {
                                    // -----------
                                    arr_ProductChanges.push('* ' + cartRow.DESCRIPTION() + ': Quantity Updated (Max. Online Stock = ' + result.QUANTITY + ')');
                                    // -----------

                                    // Increment Count
                                    // -----------
                                    Count += 1;
                                    // -----------

                                    // ----------------
                                    if (Count == max_CartRows_Count) {
                                        Display_Cart_Changes(arr_ProductChanges);
                                    }
                                    // ----------------
                                }

                                Edit_Local_Cartrows
                                (
                                    js_Cartrow,
                                    Edit_Local_CartRows_Success,
                                    null,
                                    null
                                );
                                // ##################
                            }
                            else {
                                // Increment Count
                                // -----------
                                Count += 1;
                                // -----------

                                // ----------------
                                if (Count == max_CartRows_Count) {
                                    Display_Cart_Changes(arr_ProductChanges);
                                }
                                // ----------------
                            }
                        }
                        else {
                            // INACTIVE PRODUCT
                            // -----------
                            arr_ProductChanges.push('* ' + cartRow.DESCRIPTION() + ': Removed (Online Product Inactive)');
                            // -----------

                            // Increment Count
                            // -----------
                            Count += 1;
                            // -----------

                            // ----------------
                            if (Count == max_CartRows_Count) {
                                Display_Cart_Changes(arr_ProductChanges);
                            }
                            // ----------------
                            // ----------------
                        }
                        // -------------------
                    };

                    Get_Local_Products_By_SOURCE_ID_IDPRODUCT
                    (
                        Params_Local_Products_By_SOURCE_ID_IDPRODUCT,
                        Get_Local_Products_By_SOURCE_ID_IDPRODUCT_Success,
                        null,
                        Item_Cartrow // Cartrow
                    );
                    // ------------------- 

                });

            };
            // ---------------
            DB_Initializer(MyPreEvent, MyPreEventLocalDB,MyPostEventLocalDB,MyPreEventRemoteDB, MyPostEventRemoteDB, MyOfflineEvent, My_Extra_LocalDB_Params);
            // ---------------
        }
        else {
            // ------------------------
            Checkout();
            // ------------------------
        }
        // -------------------------

        e.preventDefault();
    });

    $(this).on("click", "#Btn_ApplyDiscount", function (e) {
        // ---------------------
        var Params_Get_Local_Discorder_By_SOURCE_ID_DISCCODE_DISCSTATUS = new Object();
        Params_Get_Local_Discorder_By_SOURCE_ID_DISCCODE_DISCSTATUS.SOURCE_ID = MyApp_VM.SELECTED_SOURCE().SURROGATE_ID();
        Params_Get_Local_Discorder_By_SOURCE_ID_DISCCODE_DISCSTATUS.DISCCODE = $.trim(MyApp_VM.DISCCODE());
        Params_Get_Local_Discorder_By_SOURCE_ID_DISCCODE_DISCSTATUS.DISCSTATUS = "A";

        // ---------------------
        jq_ShowMobileLoader();
        jq_BlockUI();
        // ---------------------

        var Get_Local_Discorder_By_SOURCE_ID_DISCCODE_DISCSTATUS_Success = function (result) {
            // -----------------------
            var Edit_Local_Carthead_Success = function (result) {
                var Get_My_Cart_Info_Success = function () {
                    MyApp_VM.DISCCODE(MyApp_VM.CARTHEAD().DISCCODE);
                }
                Get_My_Cart_Info(Get_My_Cart_Info_Success);

                // ---------------------
                jq_HideMobileLoader();
                jq_UnBlockUI();
                // ---------------------
            };
            // -----------------------
            if (result != null && result.length > 0) {
                var js_discPerc, js_discAmt, js_discFromAmt, js_discToAmt, js_discValidFrom, js_discValidTo;
                var js_cartTotal;

                js_discValidFrom = result[0].DISCVALIDFROM;
                js_discValidTo = result[0].DISCVALIDTO;
                js_discPerc = result[0].DISCPERC;
                js_discAmt = result[0].DISCAMT;
                js_discFromAmt = result[0].DISCFROMAMT;
                js_discToAmt = result[0].DISCTOAMT;

                js_cartTotal = MyApp_VM.CARTHEAD().SUBTOTAL;

                if (jq_todayDate() >= jq_parseDate(js_discValidFrom) && jq_todayDate() <= jq_parseDate(js_discValidTo)) {
                    if (js_cartTotal < js_discFromAmt || js_cartTotal > js_discToAmt) {
                        jq_DisplayMessage("MSG_GeneralError", "", "Requires sub total of " + MyApp_VM.CURRENCY_SIGN() + jq_formatMoney(js_discFromAmt) + " - " + MyApp_VM.CURRENCY_SIGN() + jq_formatMoney(js_discToAmt), "Txt_DiscountCode");
                        // ---------------------
                        MyApp_VM.DISCCODE("");   // Reset DiscCode
                        // ---------------------
                        // Update order Discount
                        // ---------------------
                        MyApp_VM.CARTHEAD().DISCCODE = MyApp_VM.DISCCODE();
                        MyApp_VM.CARTHEAD().DISCPERC = 0;
                        MyApp_VM.CARTHEAD().DISCTOTAL = 0;
                        Edit_Local_Carthead(ko.mapping.toJS(MyApp_VM.CARTHEAD()), Edit_Local_Carthead_Success);
                        // ---------------------
                    }
                    else {
                        // If the order discount is NOT based on a percentage, but a fixed 
                        // amount, calculate the fixed amount as a percentage of the order.
                        if (js_discAmt > 0) {
                            js_discPerc = (js_discAmt / js_cartTotal) * 100;
                        }

                        // Update order Discount
                        // ---------------------
                        MyApp_VM.CARTHEAD().DISCCODE = MyApp_VM.DISCCODE();
                        MyApp_VM.CARTHEAD().DISCPERC = js_discPerc;
                        MyApp_VM.CARTHEAD().DISCTOTAL = MyApp_VM.CARTHEAD().SUBTOTAL * MyApp_VM.CARTHEAD().DISCPERC / 100;
                        Edit_Local_Carthead(ko.mapping.toJS(MyApp_VM.CARTHEAD()), Edit_Local_Carthead_Success);
                        // ---------------------
                    }
                }
                else {
                    jq_DisplayMessage("MSG_GeneralError", "", "Discount Code invalid or inactive.", "Txt_DiscountCode");
                    // ---------------------
                    MyApp_VM.DISCCODE("");   // Reset DiscCode
                    // ---------------------
                    // Update order Discount
                    // ---------------------
                    MyApp_VM.CARTHEAD().DISCCODE = MyApp_VM.DISCCODE();
                    MyApp_VM.CARTHEAD().DISCPERC = 0;
                    MyApp_VM.CARTHEAD().DISCTOTAL = 0;
                    Edit_Local_Carthead(ko.mapping.toJS(MyApp_VM.CARTHEAD()), Edit_Local_Carthead_Success);
                    // ---------------------
                }
            }
            else {
                if ($.trim(MyApp_VM.DISCCODE()) != "") {
                    jq_DisplayMessage("MSG_GeneralError", "", "Discount Code invalid or inactive.", "Txt_DiscountCode");
                }
                // ---------------------
                MyApp_VM.DISCCODE("");   // Reset DiscCode
                // ---------------------
                // Update order Discount
                // ---------------------
                MyApp_VM.CARTHEAD().DISCCODE = MyApp_VM.DISCCODE();
                MyApp_VM.CARTHEAD().DISCPERC = 0;
                MyApp_VM.CARTHEAD().DISCTOTAL = 0;
                Edit_Local_Carthead(ko.mapping.toJS(MyApp_VM.CARTHEAD()), Edit_Local_Carthead_Success);
                // ---------------------
            }
        };
        Get_Local_Discorder_By_SOURCE_ID_DISCCODE_DISCSTATUS(Params_Get_Local_Discorder_By_SOURCE_ID_DISCCODE_DISCSTATUS, Get_Local_Discorder_By_SOURCE_ID_DISCCODE_DISCSTATUS_Success);
        // ---------------------

        e.preventDefault();
    });

});
/*****************************************************/

// Specific page "pagebeforeshow" event //
/*****************************************************/
$(document).on("pagebeforeshow", "#pg_cart", function (event, ui) {

    var func = function () {
        // ---------------------
        jq_ShowMobileLoader();
        jq_BlockUI();
        // ---------------------

        var Get_My_Cart_Info_Success = function (result) {            
            // ---------------------
            jq_HideMobileLoader();
            jq_UnBlockUI();
            // ---------------------            
        }

        Get_My_Cart_Info(Get_My_Cart_Info_Success);
    }
    setTimeout(func, 300);
});
/*****************************************************/

// Checkout
/*****************************************************/
function Checkout() {
    // ---------------------
    MyApp_VM.LOGIN_PURPOSE("CHKOUT");   // Checkout
    // ---------------------

    // ---------------------
    if (MyApp_VM.IS_LOGGEDIN()) {
        jq_NavigateToPage("pg_customer");
    }
    else {
        jq_NavigateToPage("pg_login");
    }
    // ---------------------        
}
/*****************************************************/

// Display_Cart_Changes
/*****************************************************/
function Display_Cart_Changes(arr_Changes) {
    if (arr_Changes.length > 0) {
        jq_DisplayMessage("MSG_GeneralInfo", "Cart Updated!", arr_Changes.join('<br/>'), "Ul_Cart");

        // ---------------------
        jq_HideMobileLoader();
        jq_UnBlockUI();
        // ---------------------

        // Get Cart Info
        // ------------------------
        Get_My_Cart_Info();
        // ------------------------      
    }
    else {
        // ---------------------
        jq_HideMobileLoader();
        jq_UnBlockUI();
        // ---------------------

        // ------------------------
        Checkout();
        // ------------------------
    }
}
/*****************************************************/