﻿// Members //
/*****************************************************/
// --------------------
var Validator_Customer;
// --------------------
var Customer = new Object();
Customer.STATUS = "A";
Customer.DATECREATED = $.format.date(new Date(), "yyyy-MM-dd HH:mm:ss");
Customer.DATECREATEDINT = $.format.date(new Date(), "yyyyMMddHHmmss");
Customer.NAME = '';
Customer.LASTNAME = '';
Customer.CUSTOMERCOMPANY = '';
Customer.PHONE = '';
Customer.EMAIL = '';
Customer.PASSWORD = '';
Customer.ADDRESS = '';
Customer.CITY = '';
Customer.LOCSTATE = '';
Customer.LOCSTATE2 = '';
Customer.LOCCOUNTRY = '';
Customer.ZIP = '';
Customer.PAYMENTTYPE = "2CheckOut";
Customer.SHIPPINGNAME = '';
Customer.SHIPPINGLASTNAME = '';
Customer.SHIPPINGADDRESS = '';
Customer.SHIPPINGCITY = '';
Customer.SHIPPINGLOCSTATE = '';
Customer.SHIPPINGLOCSTATE2 = '';
Customer.SHIPPINGLOCCOUNTRY = '';
Customer.SHIPPINGZIP = '';
Customer.FUTUREMAIL = "Y";
Customer.GENERALCOMMENTS = '';
Customer.TAXEXEMPT = "N";
Customer.SHIPPINGPHONE = '';
Customer.AFFILIATE = "N";
Customer.COMMPERC = 0;
Customer.URL = '';
Customer.CONSIGN = '';
Customer.CONSIGNNEWSLETTERS = '';
Customer.CONSIGNPAYMETHOD = 0;
Customer.SHIPPINGDATE = null;
Customer.SOURCE_ID = '';
Customer.ENTRY_USER_ID = 1;
Customer.ENTRY_DATE = $.format.date(new Date(), "yyyy-MM-dd");
Customer.OWNER_ID = 1;
Customer.IDCUST = -1;
Customer.CUSTOMER_ID = -1;
var _Customer = ko.mapping.fromJS(Customer);
_Customer.DELIVERYDATE = ko.observable(null);

_Customer.FUTUREMAIL.subscribe(function (newVal) {    
    if (newVal == false) {
        _Customer.FUTUREMAIL('N');
    }
});
_Customer.DELIVERYDATE.subscribe(function (newVal) {
    _Customer.SHIPPINGDATE(newVal);    
});
/*****************************************************/

// Specific page "pagebeforecreate" event //
/*****************************************************/
$(document).on("pagebeforecreate", "#pg_customer", function (event, ui) {
    Validator_Customer = $("#Frm_customer").validate({
        rules: {
            Txt_FName_billing: { required: true },
            Txt_LName_billing: { required: true },
            Txt_Phone_billing: { required: true },
            Txt_Email_pg_customer: { required: true, email: true },
            Txt_Password_pg_customer: { required: true },
            Txt_Address_billing: { required: true },
            Txt_City_billing: { required: true },
            Ddl_Country_billing: { required: true },

            Txt_FName_shipping: { required: true },
            Txt_LName_shipping: { required: true },
            Txt_Phone_shipping: { required: true },
            Ddl_Region_shipping: { required: true },
            Txt_Town_shipping: { required: true },
            Txt_Address_shipping: { required: true },
            Ddl_DeliveryDate_shipping: { required: true },

            rd_PaymentType: { required: true }
        }
    });

    $(this).on("click", "#Btn_Next", function (e) {
        // PREPARING NON VISIBLE PROPERTIES
        // ---------------------------------
        _Customer.SOURCE_ID(MyApp_VM.SELECTED_SOURCE().SURROGATE_ID());
        _Customer.SHIPPINGLOCCOUNTRY(MyApp_VM.Get_StoreAdmin_ConfingItem('fDestCode').CONFIGVAL());
        _Customer.URL(_Customer.URL() != null ? _Customer.URL() : '');
        _Customer.CONSIGN(_Customer.CONSIGN() != null ? _Customer.CONSIGN() : '');
        _Customer.CONSIGNNEWSLETTERS(_Customer.CONSIGNNEWSLETTERS() != null ? _Customer.CONSIGNNEWSLETTERS() : '');

        /*if (_Customer.DATECREATED().indexOf('/') != -1) {
            var dt = _Customer.DATECREATED().split(' ');
            var parts = dt[0].split('/');
            var newdt = $.format.date(new Date(parts[2], parts[0] - 1, parts[1]), 'yyyy-MM-dd');
            dt.splice(0, 1, newdt);
            _Customer.DATECREATED(dt.join(' '));
        }*/
        
        if (_Customer.SHIPPINGDATE() == null) {
            var d_ShippingDate = new Date();
            d_ShippingDate.setDate(d_ShippingDate.getDate() - 1);
            _Customer.SHIPPINGDATE($.format.date(d_ShippingDate, "yyyy-MM-dd"));
        }
        else if (_Customer.SHIPPINGDATE().indexOf('/') != -1) {
            var dt = _Customer.SHIPPINGDATE().split(' ')[0];
            var parts = dt.split('/');
            _Customer.SHIPPINGDATE($.format.date(new Date(parts[2], parts[0] - 1, parts[1]), 'yyyy-MM-dd'));
        }
        // ---------------------------------

        if ($("#Frm_customer").valid()) {
            // Connection Check //
            // -------------------------            
            if (!jq_ConnectionExist()) {
                return;
            }
            // -------------------------

            // ----------------------------
            jq_ShowMobileLoader();
            jq_BlockUI();
            var Edit_Customer_Success = function (result) {
                // ---------------------
                ko.mapping.fromJS(result.My_Customer, _Customer);
                MyApp_VM.IS_LOGGEDIN(true);
                // ---------------------
                if (MyApp_VM.LOGIN_PURPOSE() == 'CHKOUT') {
                    // Get ShipmentTotal & ShipmentMethod
                    // ---------------------
                    var ShipmentTotal = 0;
                    var ShipmentMethod = '';

                    var match_Region = ko.utils.arrayFirst(MyApp_VM.REGIONS(), function (Region_Item) {
                        return Region_Item.LOCSTATE() == _Customer.SHIPPINGLOCSTATE();
                    });
                    if (match_Region) {
                        var match_Shiprates = ko.utils.arrayFirst(MyApp_VM.SHIPRATES(), function (Shiprate_Item) {
                            return Shiprate_Item.LOCSHIPZONE() == match_Region.LOCSHIPZONE();
                        });
                        if (match_Shiprates) {
                            // SHIPMENTTOTAL //
                            ShipmentTotal = match_Shiprates.ADDAMT();
                            var match_Shipmethod = ko.utils.arrayFirst(MyApp_VM.SHIPMETHOD(), function (Shipmethod_Item) {
                                return Shipmethod_Item.IDSHIPMETHOD() == match_Shiprates.IDSHIPMETHOD();
                            });
                            if (match_Shipmethod) {
                                // SHIPMENTMETHOD //
                                ShipmentMethod = match_Shipmethod.SHIPDESC();
                            }
                        }
                    }
                    // ---------------------                    

                    // Update CartHead with all info //
                    // ---------------------
                    MyApp_VM.CARTHEAD().IDCUST = _Customer.IDCUST();
                    MyApp_VM.CARTHEAD().NAME = _Customer.NAME();
                    MyApp_VM.CARTHEAD().LASTNAME = _Customer.LASTNAME();
                    MyApp_VM.CARTHEAD().ADDRESS = _Customer.ADDRESS();
                    MyApp_VM.CARTHEAD().CUSTOMERCOMPANY = _Customer.CUSTOMERCOMPANY();
                    MyApp_VM.CARTHEAD().PHONE = _Customer.PHONE();
                    MyApp_VM.CARTHEAD().EMAIL = _Customer.EMAIL();
                    MyApp_VM.CARTHEAD().CITY = _Customer.CITY();
                    MyApp_VM.CARTHEAD().LOCSTATE = MyApp_VM.GetStateDesc(_Customer.LOCSTATE());
                    MyApp_VM.CARTHEAD().LOCCOUNTRY = MyApp_VM.GetCountryDesc(_Customer.LOCCOUNTRY());
                    MyApp_VM.CARTHEAD().ZIP = _Customer.ZIP();
                    MyApp_VM.CARTHEAD().SHIPPINGNAME = _Customer.SHIPPINGNAME();
                    MyApp_VM.CARTHEAD().SHIPPINGLASTNAME = _Customer.SHIPPINGLASTNAME();
                    MyApp_VM.CARTHEAD().SHIPPINGADDRESS = _Customer.SHIPPINGADDRESS();
                    MyApp_VM.CARTHEAD().SHIPPINGCITY = _Customer.SHIPPINGCITY();
                    MyApp_VM.CARTHEAD().SHIPPINGLOCSTATE = MyApp_VM.GetStateDesc(_Customer.SHIPPINGLOCSTATE());
                    MyApp_VM.CARTHEAD().SHIPPINGLOCCOUNTRY = MyApp_VM.GetCountryDesc(_Customer.SHIPPINGLOCCOUNTRY());
                    MyApp_VM.CARTHEAD().SHIPPINGZIP = _Customer.SHIPPINGZIP();
                    MyApp_VM.CARTHEAD().SHIPPINGPHONE = _Customer.SHIPPINGPHONE();
                    MyApp_VM.CARTHEAD().PAYMENTTYPE = _Customer.PAYMENTTYPE();
                    MyApp_VM.CARTHEAD().SHIPMENTMETHOD = ShipmentMethod;
                    MyApp_VM.CARTHEAD().SHIPMENTTOTAL = ShipmentTotal;
                    MyApp_VM.CARTHEAD().SHIPPINGDATE = _Customer.SHIPPINGDATE();
                    MyApp_VM.CARTHEAD().TAXEXEMPT = _Customer.TAXEXEMPT();
                    MyApp_VM.CARTHEAD().GENERALCOMMENTS = _Customer.GENERALCOMMENTS();
                    MyApp_VM.CARTHEAD().TOTAL = MyApp_VM.CARTHEAD().SUBTOTAL - MyApp_VM.CARTHEAD().DISCTOTAL + MyApp_VM.CARTHEAD().SHIPMENTTOTAL;
                    //MyApp_VM.CARTHEAD().ORDERSTATUS = MyApp_VM.CARTHEAD().TOTAL > 0 ? '0' : '1';    // 1 = Paid; 0 = Pending

                    var Edit_Local_Carthead_Success = function (result) {
                        jq_HideMobileLoader();
                        jq_UnBlockUI();

                        // ----------------
                        Get_My_Cart_Info();
                        // ----------------

                        // ----------------
                        jq_NavigateToPage("pg_order");
                        // ----------------
                    };
                    Edit_Local_Carthead(ko.mapping.toJS(MyApp_VM.CARTHEAD()), Edit_Local_Carthead_Success);
                    // ---------------------
                }
                else if (MyApp_VM.LOGIN_PURPOSE() == 'MYACC') {
                    // ----------------
                    jq_NavigateToPage("pg_myaccount");
                    // ----------------
                }
            };
            var Edit_Customer_Failure = function () {
                jq_HideMobileLoader();
                jq_UnBlockUI();
            };
            Edit_Customer(Edit_Customer_Success, Edit_Customer_Failure);
            // ----------------------------
        }
        else {
            // Focus invalid input
            // -------------------
            Validator_Customer.focusInvalid();
            // -------------------
        }
        e.preventDefault();
    });

    $(this).on("click", "#Lnk_CardMsg_Info", function (e) {
        jq_DisplayMessage("MSG_GeneralInfo", "Card Message", "Will be printed and attached. You may write in Arabic. If you do not sign with your name, the delivery will remain anonymous.", "Lnk_CardMsg_Info");
        e.preventDefault();
    });
});
/*****************************************************/

// Specific page "pagebeforeshow" event //
/*****************************************************/
$(document).on("pagebeforeshow", "#pg_customer", function (event, ui) {
    // reset form validation
    // ------------------------------------------------------
    Validator_Customer.resetForm();
    $("input, select, textarea").removeClass("input_error");
    // ------------------------------------------------------

    // ------------------------------------------------------
    var pDelivery = MyApp_VM.DELIVERY();
    var arr_DeliveryDates = [];
    for (var i = 0; i <= 30; i++) {
        d_ShippingDate = new Date();
        d_ShippingDate.setDate(d_ShippingDate.getDate() + i);

        // $$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$
        switch (pDelivery) {
            // Sunday is 0, Monday is 1, and so on.  
            case "1": // Omit Today if it is FRIDAY
                if (i == 0 && d_ShippingDate.getDay() == 5) {     // Today is FRIDAY
                    continue;
                }
                break;
            case "2": // Omit FRIDAYS
                if (d_ShippingDate.getDay() == 5) {     // FRIDAY - Sunday is 0, Monday is 1, and so on.
                    continue;
                }
                break;
            case "3": // Omit Today if it is SUNDAY
                if (i == 0 && d_ShippingDate.getDay() == 0) {     // Today is SUNDAY
                    continue;
                }
                break;
            case "4": // Omit SUNDAYS
                if (d_ShippingDate.getDay() == 0) {     // SUNDAY
                    continue;
                }
                break;
        }
        // $$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$

        var js_DD = new Object();
        js_DD.VAL = $.format.date(d_ShippingDate, "yyyy-MM-dd")
        js_DD.DESC = i == 0 ? 'Today' : $.format.date(d_ShippingDate, 'ddd dd-MMM');
        arr_DeliveryDates.push(js_DD);
    }
    ko.mapping.fromJS(arr_DeliveryDates, MyApp_VM.DELIVERY_DATES);
    // ------------------------------------------------------    

    // Set Allowed Payment types
    /***********************************/
    MyApp_VM.PAYPAL(MyApp_VM.Get_StoreAdmin_ConfingItem('pPayPal').CONFIGVAL());
    MyApp_VM.MAILIN(MyApp_VM.Get_StoreAdmin_ConfingItem('pMailIn').CONFIGVAL());
    MyApp_VM.TWOCHECKOUT(MyApp_VM.Get_StoreAdmin_ConfingItem('TwoCheckOut').CONFIGVAL());
    /***********************************/

    // Set Cart Final Payment Type
    // ------------------- 
    if (MyApp_VM.PAYMENT_CASH() == 1) {
        MyApp_VM.CART_PAYMENT_TYPE(2);
    }
    else if (MyApp_VM.PAYMENT_CASH() == 0 && MyApp_VM.PAYMENT_NO2CO() == 1) {
        MyApp_VM.CART_PAYMENT_TYPE(1);
    }
    // -------------------     

    // -------------------
    $("#Ddl_Country_billing").selectmenu('refresh');
    $("#Ddl_Region_shipping").selectmenu('refresh');
    $("#Ddl_DeliveryDate_shipping").selectmenu('refresh');    
    $.each($("input[name='rd_PaymentType']"), function () {
        $(this).checkboxradio("refresh");
    });
    // -------------------
});
/*****************************************************/
