﻿// Members //
/*****************************************************/
// ------------------------------
var Prev_Selected_Source_ID;
// ------------------------------
MyApp_VM.Change_SelectedSource = function (data, event) {

    if ($(event.target).val() == '') {
        event.stopImmediatePropagation();
        return;
    }
    var Selected_Source_ID = $(event.target).val();

    if (MyApp_VM.CARTHEAD() != null && (MyApp_VM.CARTHEAD().SOURCE_ID) != parseInt(Selected_Source_ID) && MyApp_VM.CARTROWS().length > 0) {
        var OK_handler = function () {
            // ------------------------------
            Prev_Selected_Source_ID = Selected_Source_ID;
            // ------------------------------
            var match = ko.utils.arrayFirst(MyApp_VM.LIST_SOURCE(), function (Item_Source) {
                return Item_Source.SURROGATE_ID() == Selected_Source_ID;
            });
            
            if (match) {
                MyApp_VM.SELECTED_SOURCE(match);
            }
        };
        var CANCEL_handler = function () {
            $("#ddl_home_source").val(Prev_Selected_Source_ID).selectmenu('refresh');
        };
        jq_ConfirmationMessage("Confirmation", "We're emptying your shopping cart since you changed countries.", OK_handler, CANCEL_handler);
        //By sending to a different country your shopping cart will be emptied. 
    }
    else {
        // ------------------------------
        Prev_Selected_Source_ID = Selected_Source_ID;
        // ------------------------------
        var match = ko.utils.arrayFirst(MyApp_VM.LIST_SOURCE(), function (Item_Source) {
            return Item_Source.SURROGATE_ID() == Selected_Source_ID;
        });
        if (match) {
            MyApp_VM.SELECTED_SOURCE(match);
        }
    }
}
/*****************************************************/

// Specific page "pagebeforecreate" event //
/*****************************************************/
$(document).on("pagebeforecreate", "#pg_home", function (event, ui) {
    // Btn_Search
    // -----------------------------
    $(this).on("click", "#Btn_Search", function (e) {
        // --------------------        
        MyApp_VM.SELECTED_PRICE_SORTING(null);        
        // --------------------

        jq_NavigateToPage("pg_listing");
        
        e.preventDefault();
    });
    // -----------------------------    

    $(this).on("click", "#Btn_SearchList", function (e) {
        if ($("#div_TxtFilter").is(":visible")) {
            MyApp_VM.FILTER("");
            $("#div_TxtFilter").hide();
        }
        else {
            $("#div_TxtFilter").show();
        }
    });
});
/*****************************************************/

// Specific page "pagebeforeshow" event //
/*****************************************************/
$(document).on("pagebeforeshow", "#pg_home", function (event, ui) {
    try {
        $("#ddl_home_source").val(MyApp_VM.SELECTED_SOURCE().SURROGATE_ID()).selectmenu('refresh');
        // ------------------------------
        Prev_Selected_Source_ID = MyApp_VM.SELECTED_SOURCE().SURROGATE_ID();
        // ------------------------------
    }
    catch (e) { console.log(e.message); };

    // -------------------------    
    if ($.trim(MyApp_VM.FILTER()) == "") {
        $("#div_TxtFilter").hide();
    }
    // -------------------------
});
/*****************************************************/