﻿// Members //
/*****************************************************/
var Params_CheckOut = new Object();
Params_CheckOut.My_Carthead = new Object();
Params_CheckOut.My_Carthead.CARTHEAD_ID = -1;
Params_CheckOut.My_Carthead.TOTAL = 0;
Params_CheckOut.My_Carthead.IDORDER = -1;
Params_CheckOut.DEVICE_ID = null;
Params_CheckOut.My_Carthead.My_Cartrows = [];
var _Params_CheckOut = ko.mapping.fromJS(Params_CheckOut);
/*****************************************************/

/*****************************************************/
var _InApp_Closed = false;
/*****************************************************/

// Specific page "pagebeforecreate" event //
/*****************************************************/
$(document).on("pagebeforecreate", "#pg_order", function (event, ui) {
    $(this).on("click", "#Btn_SubmitOrder", function (e) {
        // Connection Check //
        // -------------------------            
        if (!jq_ConnectionExist()) {
            return;
        }
        // -------------------------

        // ---------------------
        jq_ShowMobileLoader();
        jq_BlockUI();
        // ---------------------

        // Update CartHead with ORDERSTATUS //
        // ---------------------
        MyApp_VM.CARTHEAD().ORDERSTATUS = MyApp_VM.CARTHEAD().TOTAL > 0 ? '0' : '1';    // 1 = Paid; 0 = Pending

        var Edit_Local_Carthead_Success = function (result) {
            // ---------------
            var Get_My_Cart_Info_Success = function () {
                // ***************************************************************************************
                // Prepare _Params_CheckOut to be sent //
                // ----------------------------                
                MyApp_VM.CARTHEAD().ORDERDATE = $.format.date(new Date(), "yyyy-MM-dd HH:mm:ss"); ;
                MyApp_VM.CARTHEAD().ORDERDATEINT = $.format.date(new Date(), "yyyyMMddHHmmss");
                MyApp_VM.CARTHEAD().My_Cartrows = [];

                ko.mapping.fromJS(ko.mapping.toJS(MyApp_VM.CARTHEAD()), {}, _Params_CheckOut.My_Carthead);
                _Params_CheckOut.My_Carthead.CARTHEAD_ID(-1);

                ko.mapping.fromJS(ko.mapping.toJS(MyApp_VM.CARTROWS()), {}, _Params_CheckOut.My_Carthead.My_Cartrows);
                // Set CARTROWS_ID to -1
                ko.utils.arrayForEach(_Params_CheckOut.My_Carthead.My_Cartrows(), function (Cartrow_Item) {
                    Cartrow_Item.CARTROWS_ID(-1);

                    // Set CARTROWSOPTIONS_ID to -1
                    ko.utils.arrayForEach(Cartrow_Item.My_Cartrowsoptions(), function (Cartrowsoption_Item) {
                        Cartrowsoption_Item.CARTROWSOPTIONS_ID(-1);
                        Cartrowsoption_Item.My_Product = null;
                    });
                });
                // ----------------------------                

                // ----------------------------
                var CheckOut_Success = function (result) {
                    // ---------------
                    jq_HideMobileLoader();
                    jq_UnBlockUI();
                    // ---------------

                    // Update _Params_CheckOut.My_Carthead from server //
                    // ---------------
                    ko.mapping.fromJS(result.My_Params_CheckOut.My_Carthead, _Params_CheckOut.My_Carthead);
                    // ---------------

                    // Set SELECTED_ORDER so that the user can check his order when returning from payment //
                    // ---------------
                    ko.mapping.fromJS(result.My_Params_CheckOut.My_Carthead, MyApp_VM.SELECTED_ORDER);
                    // ---------------

                    // Update IDORDER from server //
                    // ---------------
                    MyApp_VM.CARTHEAD().IDORDER = result.My_Params_CheckOut.My_Carthead.IDORDER;
                    // ---------------

                    // Reset some properties
                    // ---------------
                    _Customer.PAYMENTTYPE("2CheckOut");
                    _Customer.DELIVERYDATE(null);
                    // ---------------

                    // Clear Cart
                    // ------------------
                    var Clear_Cart_Success = function () {
                        // Initialize Cart
                        // ------------------------
                        var Initialize_Cart_Success = function () {
                            // Get Cart Info
                            // ------------------------
                            Get_My_Cart_Info();
                            // ------------------------

                            if (window.mobilecheck()) {
                                // ---------------
                                jq_NavigateToPage("pg_payreturn");
                                // ---------------
                            }
                        };
                        MyApp_VM.Initialize_Cart(Initialize_Cart_Success);
                        // ------------------------    
                    };

                    MyApp_VM.Clear_Cart(Clear_Cart_Success);
                    // ------------------

                    //jq_DisplayMessage("MSG_GeneralInfo", "Order", "Order successfully submitted.");

                    // Check if Mobile or not for proper redirection
                    // #############################################                    
                    var urlSSL = MyApp_VM.Get_StoreAdmin_ConfingItem('urlSSL').CONFIGVAL();
                    var urlToSend = urlSSL + '81_PayRouter.asp?paymentType=' + MyApp_VM.CARTHEAD().PAYMENTTYPE + '&idOrder=' + MyApp_VM.CARTHEAD().IDORDER + '&idCust=' + MyApp_VM.CARTHEAD().IDCUST;

                    if (window.mobilecheck()) {
                        // Open InAppBrowser //
                        // ---------------------
                        _InApp_Closed = false;

                        urlToSend += '&platform=mobile';

                        js_InAppBrowserRef = null;
                        js_InAppBrowserRef = window.open(urlToSend.replace('/?', '?'), '_blank', 'location=yes'); /*, 'location=no'*/
                        js_InAppBrowserRef.addEventListener('loadstart', function (event) {
                            /*alert('start: ' + event.url);*/
                            if (event.url.toLowerCase().indexOf("81_payreturnapp.asp") != -1) {
                                try {
                                    // ---------------
                                    _InApp_Closed = true;
                                    // ---------------

                                    // ---------------
                                    js_InAppBrowserRef.close();
                                    // ---------------

                                    // ---------------
                                    var queryString = event.url.replace(/^[^\?]+\??/, '');
                                    var params = jq_parseQuery(queryString);
                                    // ---------------

                                    // ---------------
                                    var cp_status = params["CP_Status"];
                                    var str_cp_status = cp_status.toString().toLowerCase();
                                    MyApp_VM.CP_STATUS(str_cp_status);
                                    // ---------------

                                    // ---------------
                                    //jq_NavigateToPage("pg_payreturn");
                                    // ---------------
                                }
                                catch (e) {
                                    jq_DisplayMessage("MSG_GeneralError", "", e.message);
                                }
                            }                            
                        });
                        js_InAppBrowserRef.addEventListener('loadstop', function (event) {
                            /*alert('stop: ' + event.url);*/
                            if (event.url.toLowerCase().indexOf("81_payreturnapp.asp") != -1) {
                                try {
                                    // ---------------
                                    if (_InApp_Closed == true) {
                                        return;
                                    }
                                    _InApp_Closed = true;
                                    // ---------------

                                    // ---------------
                                    js_InAppBrowserRef.close();
                                    // ---------------

                                    // ---------------
                                    var queryString = event.url.replace(/^[^\?]+\??/, '');
                                    var params = jq_parseQuery(queryString);
                                    // ---------------

                                    // ---------------
                                    var cp_status = params["CP_Status"];
                                    var str_cp_status = cp_status.toString().toLowerCase();
                                    MyApp_VM.CP_STATUS(str_cp_status);
                                    // ---------------

                                    // ---------------
                                    //jq_NavigateToPage("pg_payreturn");
                                    // ---------------
                                }
                                catch (e) {
                                    jq_DisplayMessage("MSG_GeneralError", "", e.message);
                                }
                            }                            
                        });
                        js_InAppBrowserRef.addEventListener('loaderror', function (event) { alert('error: ' + event.message); });
                        js_InAppBrowserRef.addEventListener('exit', function (event) {
                            /*alert(event.type);*/
                            try {
                                // ---------------
                                if (_InApp_Closed == true) {
                                    return;
                                }
                                // ---------------

                                // ---------------
                                js_InAppBrowserRef.close();
                                // ---------------

                                // ---------------
                                var cp_status;
                                cp_status = "unknown";
                                var str_cp_status = cp_status.toString().toLowerCase();
                                MyApp_VM.CP_STATUS(str_cp_status);
                                // ---------------

                                // ---------------
                                //jq_NavigateToPage("pg_payreturn");
                                // ---------------
                            }
                            catch (e) {
                                jq_DisplayMessage("MSG_GeneralError", "", e.message);
                            }
                        });
                        // ---------------------
                    }
                    else {
                        // MobileWeb mode
                        // --------------
                        urlToSend += '&platform=mobileweb';
                        window.location.href = urlToSend;
                    }
                    // #############################################
                };
                var CheckOut_Failure = function () {
                    // ---------------
                    jq_HideMobileLoader();
                    jq_UnBlockUI();
                    // ---------------
                };
                CheckOut(CheckOut_Success, CheckOut_Failure);
                // ----------------------------
                // ***************************************************************************************         
            }
            // ----------------
            Get_My_Cart_Info(Get_My_Cart_Info_Success);
            // ----------------              
        };
        Edit_Local_Carthead(ko.mapping.toJS(MyApp_VM.CARTHEAD()), Edit_Local_Carthead_Success);
        // ---------------------

        e.preventDefault();
    });

    $(this).on("click", "#Btn_CancelOrder", function (e) {
        // ---------------------
        jq_ShowMobileLoader();
        jq_BlockUI();
        // ---------------------

        // Reset some properties
        // ---------------
        _Customer.PAYMENTTYPE("2CheckOut");
        _Customer.DELIVERYDATE(null);
        // ---------------

        // Clear existing Cart
        // ------------------------
        MyApp_VM.Clear_Cart();
        // ------------------------

        // Initialize Cart
        // ------------------------
        MyApp_VM.Initialize_Cart();
        // ------------------------

        // Get Cart Info
        // ------------------------        
        Get_My_Cart_Info();
        // ------------------------

        // ---------------------
        jq_HideMobileLoader();
        jq_UnBlockUI();
        // ---------------------
        jq_NavigateToPage("pg_home");
    });
});
/*****************************************************/

// Specific page "pagebeforeshow" event //
/*****************************************************/
$(document).on("pagebeforeshow", "#pg_order", function (event, ui) {
    // Get DEVICE_ID
    // --------------------------------------                
    var Get_Device_Data_By_Key_Success_DEVICE_ID = function (result) {
        if (result.length > 0) {
            //---------
            _Params_CheckOut.DEVICE_ID(result[0].DATA_VALUE);
            //---------
        }
    };
    Get_Device_Data_By_Key("DEVICE_ID", Get_Device_Data_By_Key_Success_DEVICE_ID);
    // --------------------------------------                    
});
/*****************************************************/